#!/usr/bin/env python
# coding: utf-8

# In[1]:


import os

import tkinter as tk
import tkinter.messagebox as box
from tkinter import filedialog
import json
import itkdb
import webbrowser



def lookup_interface():


    
    app = tk.Toplevel()
    app.title('Database Lookup')

    #bring window to top and make active
    app.lift()
    app.focus_force()
    app.grab_set()
    app.grab_release()
    

    label_top = tk.Label(app, text='Database Lookup Interface', bg='blue', fg='white', font=('Arial Black', 12, 'bold'))
    label_top.pack(padx = 10, pady = 10)
    
    
    #global variables from function access
    global client
    client = None
    
    ####################################################################################################
    #####Password verification
    
    
    print('##############################')
    
    
    frame_pw1 = tk.Frame(app)
    frame_pw1.pack(padx=10, pady=10)
    
    label_pw = tk.Label(frame_pw1, text='Please enter database passwords and press button first.'
                        , wraplength=300 ,width=50, justify='left', bg='yellow') 
    label_pw.grid(row=0, column=1, columnspan=2)
    
    
    label_pw1 = tk.Label(frame_pw1, text='Access Code 1: ')
    label_pw1.grid(sticky="w", row=1, column=1)
    pw1 = tk.StringVar()
    entry_pw1 = tk.Entry(frame_pw1, textvariable = pw1)
    entry_pw1['show'] = '*'
    entry_pw1.grid(sticky="w", row=1, column=2)

    label_pw2 = tk.Label(frame_pw1, text='Access Code 2: ')
    label_pw2.grid(sticky="w", row=2, column=1)
    pw2 = tk.StringVar()
    entry_pw2 = tk.Entry(frame_pw1, textvariable = pw2)
    entry_pw2['show'] = '*'
    entry_pw2.grid(sticky="w", row=2, column=2)
  
    


    def pw_read():
        global client
        db_password1 = pw1.get()
        db_password2 = pw2.get()
        if db_password1 and db_password2 :
            try:
                u = itkdb.core.User(access_code1=db_password1, access_code2=db_password2)
                client = itkdb.Client(user = u)
                client.user.authenticate()
                dbUser = client.get('getUser', json={"userIdentity": client.user.identity })
                print( "Hello {} {}, \nwelcome to the ITk database".format(dbUser["firstName"], dbUser["lastName"]))
                entry_pw1.configure({'background': 'lime'})
                entry_pw2.configure({'background': 'lime'})
                label_pw.configure({'background': 'lightgrey'})
                pw_button.configure({'background': 'lime'})
            except Exception as e:
                print(e)
                box.showerror( 'Error', 'Wrong Passwords' )
                db_password1 = None
                db_password2 = None
                pw1.set('')
                pw2.set('')
                entry_pw1.configure({'background': 'red'})
                entry_pw2.configure({'background': 'red'}) 
                pw_button.configure({'background': 'red'})
                client = None
        elif "ITKDB_ACCESS_CODE1" in os.environ and "ITKDB_ACCESS_CODE1" in os.environ:
            try: 
                client = itkdb.Client()
                client.user.authenticate()
                dbUser = client.get('getUser', json={'userIdentity': client.user.identity})
                print( "Hello {} {}, \nwelcome to the ITk database".format(dbUser["firstName"], dbUser["lastName"]))
                entry_pw1.configure({'background': 'lime'})
                entry_pw2.configure({'background': 'lime'})
                label_pw.configure({'background': 'lightgrey'})
                pw_button.configure({'background': 'lime'})
            except Exception as e:
                box.showerror( 'Error', 'Wrong Passwords' )
                db_password1 = None
                db_password2 = None
                pw1.set('')
                pw2.set('')
                entry_pw1.configure({'background': 'red'})
                entry_pw2.configure({'background': 'red'})
                pw_button.configure({'background': 'red'})
                client = None
        elif os.path.exists(".env"):
            try: 
                client = itkdb.Client()
                client.user.authenticate()
                dbUser = client.get('getUser', json={'userIdentity': client.user.identity})
                print( "Hello {} {}, \nwelcome to the ITk database".format(dbUser["firstName"], dbUser["lastName"]))
                entry_pw1.configure({'background': 'lime'})
                entry_pw2.configure({'background': 'lime'})
                label_pw.configure({'background': 'lightgrey'})
                pw_button.configure({'background': 'lime'})
            except Exception as e:
                box.showerror( 'Error', 'Wrong Passwords' )
                db_password1 = None
                db_password2 = None
                pw1.set('')
                pw2.set('')
                entry_pw1.configure({'background': 'red'})
                entry_pw2.configure({'background': 'red'})
                pw_button.configure({'background': 'red'})
                client = None
        else: 
            box.showwarning( 'Warning', 'Please Enter Passwords' )
            entry_pw1.configure({'background': 'yellow'})
            entry_pw2.configure({'background': 'yellow'}) 
            client = None

    pw_button = tk.Button(frame_pw1, text='Get Password', width=25, command = pw_read, bg='yellow' )
    pw_button.grid(row=3, column=1, columnspan=2)
    

    
    
    
    ##############Input and Output
    
    
    
    frame_input = tk.Frame(app)
    frame_input.pack(padx = 10, pady = 10)
    
    compnameLabel = tk.Label(frame_input, text='Component ID: ', width = 20, justify=tk.RIGHT, anchor="e" )
    compnameLabel.grid(row=0, column=1)
    componentName = tk.StringVar()
    compname = tk.Entry(frame_input, textvariable = componentName, width = 30)
    compname.grid(row=0, column=2, columnspan=2, sticky=tk.W)
    compnameDescription = tk.Label(frame_input, text='ATLAS ID or Alternative Identifier', width = 30, justify=tk.LEFT, anchor="w")
    compnameDescription.grid(row=1, column=2, columnspan=2, sticky=tk.W )
    
    
    altIdLabel = tk.Label(frame_input, text='Alternative ID?', width = 20, justify=tk.RIGHT, anchor="e" )
    altIdLabel.grid(row=2, column=1)
    altID = tk.BooleanVar()
    radio_alt_no = tk.Radiobutton (frame_input, text='False', variable = altID, value = False)
    radio_alt_yes = tk.Radiobutton (frame_input, text='True', variable = altID, value = True)
    radio_alt_yes.select()
    radio_alt_yes.grid(row=2, column=2 )
    radio_alt_no.grid(row=2, column=3)
    

    
    
    detailOutLabel = tk.Label(frame_input, text='Detail Terminal Output?', width = 20, justify=tk.RIGHT, anchor="e" )
    detailOutLabel.grid(row=3, column=1)
    detailOut = tk.BooleanVar()
    detailOut_no = tk.Radiobutton (frame_input, text='No', variable = detailOut, value = False)
    detailOut_yes = tk.Radiobutton (frame_input, text='Yes', variable = detailOut, value = True)
    detailOut_no.select()
    detailOut_yes.grid(row=3, column=2 )
    detailOut_no.grid(row=3, column=3)
    
    
    
    
    frame_buttons = tk.Frame(app)
    frame_buttons.pack(padx = 10, pady = 10)
    
    
    def get_component():
        if not client:
            print( 'Database access not possible, please enter passwords first and click on "Get Password".')
            box.showwarning( 'Warning', 'Please Get Passwords first.' )
            return

        print( 'Retrieving component information for ', componentName.get() )

        
        try:
            component = client.get('getComponent', json={"component":componentName.get(), "alternativeIdentifier":altID.get()})
        except:
            box.showerror( 'Error', 'Component not found.' )
            print( 'Could not retrieve component information. Is the component name correct?' )
            if(altID.get()):
                print( f"Is {componentName.get()} an alternative identifier?" )
            elif(altID.get()==False):
                print( f"Is {componentName.get()} an ATLAS ID (or database id)?" )
            
            return
        
        if detailOut.get() == True:
            print(json.dumps(component, indent=3) )
        
        
        
        if "serialNumber" in component: componentATLASName.set(component["serialNumber"])
        if "alternativeIdentifier" in component: componentAltIDName.set(component["alternativeIdentifier"])
        componentDBName.set(component["code"])
        compAssembledName.set( str(component["assembled"]) )
        compLocationName.set( component["currentLocation"]["name"] )
        #webaddress = "https://itkpd-test.unicorncollege.cz/componentView?code=" + component["code"]
        webaddress = "https://itkpd-test.unicorncollege.cz/componentView?code=" + component["code"]
        compWebName.set(webaddress)
        #compTransitName.set( str(component["inTransit"]) )
        compTransitName.set('Yes') if component["inTransit"] else compTransitName.set('No')
        if component["inTransit"]: compDestinationName.set( component["shipmentDestination"]["name"])
        compStageName.set( component["currentStage"]["code"])
        
        
        if component["children"]:
            print("Children: ")
            compChildrenName.set('No')
            for child in component["children"]:
                if child["component"] != None: 
                    compChildrenName.set('Yes')
                    if "serialNumber" in child["component"]:
                        print( child["component"]["serialNumber"] )
    
    
    get_component_button = tk.Button(frame_buttons, text='Get Component Info', width=25, command=get_component, bg='green yellow')
    get_component_button.grid(row=0, column=0, padx=10, pady=10)
    
    
    def clear():
        componentName.set('')
        radio_alt_yes.select()
        
    
    clear_button = tk.Button(frame_buttons, text='Clear', width = 15, command=clear, bg='DarkOrange1')
    clear_button.grid(row=0, column=1, padx = 10, pady = 10)
    
    
    
    
    frame_output = tk.Frame(app)
    frame_output.pack(padx = 10, pady = 10)
    row_count = 0
    
    
    compnameATLASLabel = tk.Label(frame_output, text='Component ATLAS ID: ', width = 23, justify=tk.RIGHT, anchor="e"  )
    compnameATLASLabel.grid(row=row_count, column=1)
    componentATLASName = tk.StringVar()
    compnameATLAS = tk.Entry(frame_output, textvariable = componentATLASName, width = 20)
    compnameATLAS.grid(row=row_count, column=2, sticky=tk.W)
    
    
    row_count += 1
    compnameAltIDLabel = tk.Label(frame_output, text='Alternative ID: ', width = 23, justify=tk.RIGHT, anchor="e"  )
    compnameAltIDLabel.grid(row=row_count, column=1)
    componentAltIDName = tk.StringVar()
    compnameAltID = tk.Entry(frame_output, textvariable = componentAltIDName, width = 40)
    compnameAltID.grid(row=row_count, column=2, sticky=tk.W)
    
    
    row_count += 1
    compnameDBLabel = tk.Label(frame_output, text='Component DB ID: ', width = 23, justify=tk.RIGHT, anchor="e"  )
    compnameDBLabel.grid(row=row_count, column=1)
    componentDBName = tk.StringVar()
    compnameDB = tk.Entry(frame_output, textvariable = componentDBName, width = 40)
    compnameDB.grid(row=row_count, column=2, sticky=tk.W)
    
    
    row_count += 1
    compAssembledLabel = tk.Label(frame_output, text='Is assembled to something? ', width = 23, justify=tk.RIGHT, anchor="e"  )
    compAssembledLabel.grid(row=row_count, column=1)
    compAssembledName = tk.StringVar()
    compAssembled = tk.Entry(frame_output, textvariable = compAssembledName, width = 20, state=tk.DISABLED)
    compAssembled.grid(row=row_count, column=2, sticky=tk.W)
    
    
    row_count += 1
    compLocationLabel = tk.Label(frame_output, text='Current Location: ', width = 23, justify=tk.RIGHT, anchor="e"  )
    compLocationLabel.grid(row=row_count, column=1)
    compLocationName = tk.StringVar()
    compLocation = tk.Entry(frame_output, textvariable = compLocationName, width = 40, state=tk.DISABLED)
    compLocation.grid(row=row_count, column=2, sticky=tk.W)
    
    
    
    
    row_count += 1
    compTransitLabel = tk.Label(frame_output, text='In Transit?', width = 23, justify=tk.RIGHT, anchor="e"  )
    compTransitLabel.grid(row=row_count, column=1)
    compTransitName = tk.StringVar()
    compTransit = tk.Entry(frame_output, textvariable = compTransitName, width = 20, state=tk.DISABLED)
    compTransit.grid(row=row_count, column=2, sticky=tk.W)
    
    
    row_count += 1
    compDestinationLabel = tk.Label(frame_output, text='Destination: ', width = 23, justify=tk.RIGHT, anchor="e"  )
    compDestinationLabel.grid(row=row_count, column=1)
    compDestinationName = tk.StringVar()
    compDestination = tk.Entry(frame_output, textvariable = compDestinationName, width = 40, state=tk.DISABLED)
    compDestination.grid(row=row_count, column=2, sticky=tk.W)
    
    
    row_count += 1
    compStageLabel = tk.Label(frame_output, text='Stage: ', width = 23, justify=tk.RIGHT, anchor="e" )
    compStageLabel.grid(row=row_count, column=1)
    compStageName = tk.StringVar()
    compStage = tk.Entry(frame_output, textvariable = compStageName, width = 30, state=tk.DISABLED)
    compStage.grid(row=row_count, column=2, sticky=tk.W)
    
    
    row_count += 1
    compChildrenLabel = tk.Label(frame_output, text='Has assembled children?', width = 23, justify=tk.RIGHT, anchor="e"  )
    compChildrenLabel.grid(row=row_count, column=1)
    compChildrenName = tk.StringVar()
    compChildren = tk.Entry(frame_output, textvariable = compChildrenName, width = 30, state=tk.DISABLED)
    compChildren.grid(row=row_count, column=2, sticky=tk.W)
    
    
    
    row_count += 1
    compWebLabel = tk.Label(frame_output, text='Component Website: ', width = 23, justify=tk.RIGHT, anchor="e"  )
    compWebLabel.grid(row=row_count, column=1)
    compWebName = tk.StringVar()
    compWeb = tk.Entry(frame_output, textvariable = compWebName, width = 40)
    compWeb.grid(row=row_count, column=2, sticky=tk.W)
    
    
    def web_tab():
        webbrowser.open(compWebName.get(), new = 2)
    
    row_count += 1
    webTab_button = tk.Button(frame_output, text='Open in Browser', width = 25, command=web_tab, bg='light blue')
    webTab_button.grid(row=row_count, column=2)
    

    
    
    
    
    
    
    def trace_feature(self, *args):
        componentATLASName.set('')
        componentAltIDName.set('')
        componentDBName.set('')
        compAssembledName.set('')
        compLocationName.set('')
        compWebName.set('')
        compTransitName.set('')
        compDestinationName.set('')
        compStageName.set('')
        compChildrenName.set('')
        
    
    
    
    componentName.trace('w', trace_feature )
    
    
    
    
    
    
    
    
    
    exit_button = tk.Button(app, text='Close', width=25, command=app.destroy, bg = 'red' )
    exit_button.pack(padx = 10, pady = 10)

    app.mainloop()
    
    
    
if __name__ == "__main__":
    window = tk.Tk()
    #window.withdraw()
    
    quit_button = tk.Button(window, text='Close All', width=25, command=window.destroy, bg = 'red' )
    quit_button.pack(padx = 10, pady = 10)
    
    
    
    lookup_interface()
    
          
        


# In[ ]:




