#!/usr/bin/env python
# coding: utf-8

# In[3]:


import tkinter as tk
from tkinter import ttk
from tkinter import filedialog
import tkinter.messagebox as box
from glob import glob
from datetime import datetime, timezone, date
import json
from tkcalendar import DateEntry

def flex_thickness_popup():
    
    
    
    
    app = tk.Toplevel()
    
    #bring appdow to top and make active
    app.lift()
    app.focus_force()
    app.grab_set()
    app.grab_release()
   
    app.title('Flex Thickness Interface')
    
    labelTitle = tk.Label(app, text='Flex Thickness', bg='blue', fg='white', font=('Arial Black', 12, 'bold'))
    labelTitle.pack(padx = 10, pady = 10)

    
    
    
    
    
    
    frame_line1 = tk.Frame(app)
    frame_line1.pack()
    compnameLabel = tk.Label(frame_line1, text='Database ID: ', width = 15 )
    compnameLabel.pack(side = tk.LEFT, padx = 10, pady = 10)
    componentName = tk.StringVar()
    compname = tk.Entry(frame_line1, textvariable = componentName)
    compname.pack(side = tk.RIGHT, padx = 10, pady = 10)
    #componentName.trace('w', compname.configure({'background': 'white'}))
    
    def trace_feature(self, *args):
        compname.configure({'background': 'white'})
    
    componentName.trace('w', trace_feature )
    
    
    frame_line2 = tk.Frame(app)
    frame_line2.pack()
    altIdLabel = tk.Label(frame_line2, text='Alternative ID?', width = 15 )
    altIdLabel.pack( side=tk.LEFT, padx=10, pady=10)
    altID = tk.BooleanVar()
    radio_alt_no = tk.Radiobutton (frame_line2, text='False', variable = altID, value = False)
    radio_alt_yes = tk.Radiobutton (frame_line2, text='True', variable = altID, value = True)
    radio_alt_yes.select()
    radio_alt_no.pack( side = tk.RIGHT )
    radio_alt_yes.pack( side = tk.RIGHT )
    
    
    frame_line3 = tk.Frame(app)
    frame_line3.pack()
    compTypeLabel = tk.Label(frame_line3, text='Component Type: ', width = 15 )
    compTypeLabel.pack( side=tk.LEFT, padx=10, pady=10 )
    componentType = ttk.Combobox(frame_line3, width = 30)
    componentType['values'] = ( 'HYBRID_FLEX_ARRAY') #'HYBRID_FLEX_TEST_COUPON' )
    componentType.pack( side=tk.RIGHT, padx=10, pady=10)
    componentType.set('HYBRID_FLEX_ARRAY')
    
    
    
    
    frame_line4 = tk.Frame(app)
    frame_line4.pack()
    compStageLabel = tk.Label(frame_line4, text='Component Stage: ', width = 15 )
    compStageLabel.pack( side=tk.LEFT, padx=10, pady=10 )
    componentStage = ttk.Combobox(frame_line4, width = 30)
    componentStage['values'] = (  'FROM_MANUFACTURER',
                                  'SMD_POPULATED') #'FROM_MANUFACTURER','AFTER_REFLOW' )
    componentStage.pack( side=tk.RIGHT, padx=10, pady=10)
    
    
    
    frame_line51 = tk.Frame(app)
    frame_line51.pack()
    runNumberLabel = tk.Label(frame_line51, text='Run Number: ', width = 15 )
    runNumberLabel.pack( side=tk.LEFT, padx=10, pady=10 )
    runNumber = ttk.Combobox(frame_line51, width = 5)
    runNumber['values'] = ( '1',
                            '2',
                            '3',
                            '4',
                            '5',
                            '6',
                            '7',
                            '8',
                            '9',
                            '10')
    runNumber.pack( side=tk.RIGHT, padx=10, pady=10)
    runNumber.set('1')
    
    #Option for measurement date
    frame_line52 = tk.Frame(app)
    frame_line52.pack()
    date_Label = tk.Label(frame_line52, text='Measurement Date: ', width = 25, justify=tk.RIGHT, anchor="e")
    date_Label.grid(row=1, column=1)
    cal = DateEntry(frame_line52, width=12, background='darkblue', maxdate=date.today(), 
                    foreground='white', borderwidth=2, dateformat=4, date_pattern='yyyy-mm-dd')
    cal.grid(row=1, column=2)
      
    
    frame_line6 = tk.Frame(app)
    frame_line6.pack()
    passFail = tk.Label(frame_line6, text='Test Result: ', width = 15 )
    passFail.pack( side=tk.LEFT, padx=10, pady=10)
    passed = tk.BooleanVar()
    radio_passed = tk.Radiobutton (frame_line6, text='Passed', variable = passed, value = True)
    radio_failed = tk.Radiobutton (frame_line6, text='Failed', variable = passed, value = False)
    radio_passed.select()
    radio_failed.pack( side = tk.RIGHT )
    radio_passed.pack( side = tk.RIGHT )
    
    
    
    frame_line61 = tk.Frame(app)
    frame_line61.pack()
    problemsLabel = tk.Label(frame_line61, text='Problems: ', width = 15 )
    problemsLabel.pack( side=tk.LEFT, padx=10, pady=10)
    problems = tk.BooleanVar()
    radio_prob_yes = tk.Radiobutton (frame_line61, text='Yes', variable = problems, value = True)
    radio_prob_no = tk.Radiobutton (frame_line61, text='No', variable = problems, value = False)
    radio_prob_no.select()
    radio_prob_no.pack( side = tk.RIGHT )
    radio_prob_yes.pack( side = tk.RIGHT )
    
    
    frame_line7 = tk.Frame(app)
    frame_line7.pack()
    operator_Label = tk.Label(frame_line7, text='Operator: ', width = 15 )
    operator_Label.pack(side = tk.LEFT, padx = 10, pady = 10)
    operator_Name = tk.StringVar()
    operator = tk.Entry(frame_line7, textvariable = operator_Name)
    operator.pack(side = tk.RIGHT, padx = 10, pady = 10)
    
    frame_line8 = tk.Frame(app)
    frame_line8.pack()
    setup_Label = tk.Label(frame_line8, text='Setup: ', width = 15 )
    setup_Label.pack(side = tk.LEFT, padx = 10, pady = 10)
    setup_Name = tk.StringVar()
    setup_Name.set("Micrometer")
    setup = tk.Entry(frame_line8, textvariable = setup_Name)
    setup.pack(side = tk.RIGHT, padx = 10, pady = 10)
    
    
    
    
    
    frame_line9 = tk.Frame(app)
    frame_line9.pack()
    tc_Label = tk.Label(frame_line9, text='Test Coupon Thickness [um]: ', width = 25 )
    tc_Label.pack(side = tk.LEFT, padx = 10, pady = 10)
    tc_thickness_Name = tk.StringVar()
    tc_thickness = tk.Entry(frame_line9, textvariable = tc_thickness_Name, width=35)
    tc_thickness.pack(side = tk.RIGHT, padx = 10, pady = 10)
    
    
    frame_line10 = tk.Frame(app)
    frame_line10.pack()
    hybrid_Label = tk.Label(frame_line10, text='Hybrid Thickness [um]: ', width = 25 )
    hybrid_Label.pack(side = tk.LEFT, padx = 10, pady = 10)
    hybrid_thickness_Name = tk.StringVar()
    hybrid_thickness = tk.Entry(frame_line10, textvariable = hybrid_thickness_Name, width=65)
    hybrid_thickness.pack(side = tk.RIGHT, padx = 10, pady = 10)
    
   
    
    
    
    def get_save_directory():
        saveDirectory.set( filedialog.askdirectory(initialdir = "./",title = "Select Directory") )
        #print ( saveDirectory.get() )
    
    
    frame_line8 = tk.Frame(app)
    frame_line8.pack()
    directoryLabel = tk.Label(frame_line8, text='Json saved in directory:', width=20)
    directoryLabel.pack(side = tk.LEFT, padx=10, pady=10)
    dir_button = tk.Button(frame_line8, text='Save Directory', width = 20, command = get_save_directory )
    dir_button.pack( side= tk.RIGHT, padx = 10, pady = 10)
    
    saveDirectory = tk.StringVar()
    saveDirLabel = tk.Label(app, textvariable=saveDirectory, width=60, bg='grey', wraplength=350)
    saveDirLabel.pack(padx=10, pady=10)
    
    
    
    
    def create_json():
        print ( "Component Name: ", componentName.get() )
        
        if componentName.get() == '' or componentType.get() == '' or componentStage.get() == ''           or saveDirectory.get() == '' or operator.get() == '':
            #  or tc_thickness.get() == '' or hybrid_thickness.get() == ''
            box.showerror( 'Error', 'Please Complete all user fields and pick a save directory.' )
        else:
            
            if tc_thickness_Name.get() != '':
                list_tc_thickness = tc_thickness.get().split(",") 
                for entry in list_tc_thickness :
                    try:
                        float(entry)
                    except ValueError:
                        box.showerror( 'Error', 'Test Coupon Thickness value not a float.' )
                        return
            if hybrid_thickness_Name.get() != '':
                list_hybrid_thickness = hybrid_thickness.get().split(",") 
                for entry in list_hybrid_thickness :
                    try:
                        float(entry)
                    except ValueError:
                        box.showerror( 'Error', 'Hybrid Thickness value not a float.' )
                        return
                    
            #Measurement Date (using current time)
            datetimeobject = datetime.combine( cal.get_date(), datetime.now(timezone.utc).time() )
          
            out_dictionary = {}  ##dictionary for output
            out_dictionary.update({"componentType": componentType.get() }) 
            out_dictionary.update({"component": componentName.get() })             
            out_dictionary.update({"alternativeIdentifier": altID.get() })    
            out_dictionary.update({"currentStage": componentStage.get() })        
            out_dictionary.update({"testType" : "THICKNESS" })
            out_dictionary.update({"institution" : "LIV"})
            out_dictionary.update({"runNumber" : int( runNumber.get() ) })                           
            out_dictionary.update({"date" : datetimeobject.astimezone().isoformat(timespec='milliseconds') })      
            out_dictionary.update({"passed" : passed.get() })
            out_dictionary.update({"problems" : problems.get() })
            out_dictionary.update({"properties": { 
                                      "OPERATOR": operator.get(),
                                      "SETUP" : setup.get()
                                      }
                                  })
            out_dictionary.update({"results" :{ 
                                    "THICKNESS_TEST_COUPON": None , 
                                    "THICKNESS_HYBRID": None 
                                } })
            if tc_thickness_Name.get() != '':
                out_dictionary["results"]["THICKNESS_TEST_COUPON"] = list( map(float, tc_thickness.get().split(",")) )
                #out_dictionary.update({"results" :{ 
                #                    "THICKNESS_TEST_COUPON": list( map(float, tc_thickness.get().split(",")) )
                #                } })
            if hybrid_thickness_Name.get() != '':
                out_dictionary["results"]["THICKNESS_HYBRID"] = list( map(float, hybrid_thickness.get().split(",")) )
            #    out_dictionary.update({"results" :{ 
            #                        "THICKNESS_HYBRID": list( map(float, hybrid_thickness.get().split(",")) )
            #                    } })
                
            #out_dictionary.update({"results" :{ 
            #                        "THICKNESS_TEST_COUPON": list( map(float, tc_thickness.get().split(",")) ) , 
            #                        "THICKNESS_HYBRID": list( map(float, hybrid_thickness.get().split(",")) )
            #                    } })
            
                
            
            
            #########save json file#######################################
    
            out_file_name = componentName.get() + '_THICKNESS_' + componentStage.get() + '_' + runNumber.get()
            out_file = saveDirectory.get() +'\\' + out_file_name + '.json'
 
            print(f"Json output file: {out_file}")
            
            with open( out_file, 'w' ) as outfile:
                json.dump(out_dictionary, outfile, indent=4)  #indent makes it human readable
            
            compname.configure({'background': 'lime'})
            
            
            #clear thickness values
            tc_thickness.delete(0,'end')
            hybrid_thickness.delete(0,'end')
    
    
    def clear_fields():
        compname.delete(0,'end')
        componentType.delete(0,'end')
        componentStage.delete(0,'end')
        comment.delete('1.0','end')
        tc_thickness.delete(0,'end')
        hybrid_thickness.delete(0,'end')
        saveDirectory.set('')
    
    
    frame_button = tk.Frame(app)
    frame_button.pack()
    create_button = tk.Button(frame_button, text='Create Json', width = 25, command=create_json)
    create_button.pack(side = tk.LEFT, padx = 10, pady = 10)
    clear_button = tk.Button(frame_button, text='Clear All', width = 25, command=clear_fields)
    clear_button.pack(side = tk.RIGHT, padx = 10, pady = 10)
    
    
    
    
    
    exit_button = tk.Button(app, text='Close', width=25, command=app.destroy, bg = 'red' )
    exit_button.pack(padx = 10, pady = 10)


    app.mainloop()
    
    
    
    
if __name__ == "__main__":
    window = tk.Tk()
    #window.withdraw()
    
    quit_button = tk.Button(window, text='Close All', width=25, command=window.destroy, bg = 'red' )
    quit_button.pack(padx = 10, pady = 10)
    
    flex_thickness_popup()


# {
#   "component": "...",
#   "testType": "THICKNESS",
#   "institution": "...",
#   "runNumber": "...",
#   "date": "2022-03-23T16:31:57.677Z",
#   "passed": true,
#   "problems": false,
#   "properties": {
#     "OPERATOR": "KAEQKMIMNTXQPPKOCUOVWTWUTMJVQY",
#     "SETUP": "USSNCIAGFEQPKEUAEGNSMJQOONQYFD"
#   },
#   "results": {
#     "THICKNESS_TEST_COUPON": [
#       53.790492319042215,
#       53.790492319042215
#     ],
#     "THICKNESS_HYBRID": [
#       84.78518629439566,
#       84.78518629439566
#     ]
#   }
# }
