#!/usr/bin/env python
# coding: utf-8

# to do:
# 
# automatic stage change for hybrid flex to "On hybrid"

# In[1]:


import tkinter as tk
import tkinter.messagebox as box
from tkinter import filedialog
from tkinter import ttk
import json
import itkdb
import time
import os

def hybrid_assembly_interface():
    #global variables from function access

    #global variables from function access
    global client
    client = None

    
    app = tk.Toplevel()
    app.title('User Interface')

    
    
    #bring window to top and make active
    app.lift()
    app.focus_force()
    app.grab_set()
    app.grab_release()
        
    
    label_head = tk.Label(app, text='Hybrid Flex Panel Registration', bg='blue', fg='white', font=('Arial Black', 12, 'bold'))
    label_head.pack(padx = 10, pady = 10)
    
    
    #####Password verification
    
    
    frame_pw1 = tk.Frame(app)
    frame_pw1.pack(padx=10, pady=10)
    
    label_pw = tk.Label(frame_pw1, text='Please enter database passwords and press button first.'
                        , wraplength=300 ,width=50, justify='left', bg='yellow') 
    label_pw.grid(row=0, column=1, columnspan=2)
    
    
    label_pw1 = tk.Label(frame_pw1, text='Access Code 1: ')
    label_pw1.grid(sticky="w", row=1, column=1)
    pw1 = tk.StringVar()
    entry_pw1 = tk.Entry(frame_pw1, textvariable = pw1)
    entry_pw1['show'] = '*'
    entry_pw1.grid(sticky="w", row=1, column=2)

    label_pw2 = tk.Label(frame_pw1, text='Access Code 2: ')
    label_pw2.grid(sticky="w", row=2, column=1)
    pw2 = tk.StringVar()
    entry_pw2 = tk.Entry(frame_pw1, textvariable = pw2)
    entry_pw2['show'] = '*'
    entry_pw2.grid(sticky="w", row=2, column=2)
  
    


    def pw_read():
        global client
        db_password1 = pw1.get()
        db_password2 = pw2.get()
        if db_password1 and db_password2 :
            try:
                u = itkdb.core.User(access_code1=db_password1, access_code2=db_password2)
                client = itkdb.Client(user = u)
                client.user.authenticate()
                user = client.get('getUser', json={'userIdentity': client.user.identity})
                print( "Hello {} {}, \nwelcome to the ITk database'".format(user["firstName"], user["lastName"]))
                entry_pw1.configure({'background': 'lime'})
                entry_pw2.configure({'background': 'lime'})
                label_pw.configure({'background': 'lightgrey'})
                pw_button.configure({'background': 'lime'})
            except Exception as e:
                print(e)
                box.showerror( 'Error', 'Wrong Passwords' )
                db_password1 = None
                db_password2 = None
                pw1.set('')
                pw2.set('')
                entry_pw1.configure({'background': 'red'})
                entry_pw2.configure({'background': 'red'}) 
                pw_button.configure({'background': 'red'})
                client = None
        elif "ITKDB_ACCESS_CODE1" in os.environ and "ITKDB_ACCESS_CODE1" in os.environ:
            try: 
                client = itkdb.Client()
                client.user.authenticate()
                user = client.get('getUser', json={'userIdentity': client.user.identity})
                print( "Hello {} {}, \nwelcome to the ITk database'".format(user["firstName"], user["lastName"]))
                entry_pw1.configure({'background': 'lime'})
                entry_pw2.configure({'background': 'lime'})
                label_pw.configure({'background': 'lightgrey'})
                pw_button.configure({'background': 'lime'})
            except Exception as e:
                box.showerror( 'Error', 'Wrong Passwords' )
                db_password1 = None
                db_password2 = None
                pw1.set('')
                pw2.set('')
                entry_pw1.configure({'background': 'red'})
                entry_pw2.configure({'background': 'red'})
                pw_button.configure({'background': 'red'})
                client = None
        elif os.path.exists(".env"):
            try: 
                client = itkdb.Client()
                client.user.authenticate()
                dbUser = client.get('getUser', json={'userIdentity': client.user.identity})
                print( "Hello {} {}, \nwelcome to the ITk database".format(dbUser["firstName"], dbUser["lastName"]))
                entry_pw1.configure({'background': 'lime'})
                entry_pw2.configure({'background': 'lime'})
                label_pw.configure({'background': 'lightgrey'})
                pw_button.configure({'background': 'lime'})
            except Exception as e:
                box.showerror( 'Error', 'Wrong Passwords' )
                db_password1 = None
                db_password2 = None
                pw1.set('')
                pw2.set('')
                entry_pw1.configure({'background': 'red'})
                entry_pw2.configure({'background': 'red'})
                pw_button.configure({'background': 'red'})
                client = None
        else: 
            box.showwarning( 'Warning', 'Please Enter Passwords' )
            entry_pw1.configure({'background': 'yellow'})
            entry_pw2.configure({'background': 'yellow'}) 
            client = None

    pw_button = tk.Button(frame_pw1, text='Get Password', width=25, command = pw_read, bg='yellow' )
    pw_button.grid(row=3, column=1, columnspan=2)
    
    
    
    label_subsection = tk.Label(app, text='Hybrid Assembly', bg='deepskyblue', fg='black', font=('Arial Black', 10))
    label_subsection.pack(padx = 10, pady = 10)
    
    
       
    
    
    
    #hybrid test panel name
    frame_panel = tk.Frame(app)
    frame_panel.pack(padx = 10, pady = 10)
    
    panelLabel = tk.Label(frame_panel, text='Hybrid Test Panel ATLAS ID: ', width = 25 )
    panelLabel.grid(row=1, column=1)
    panelName = tk.StringVar()
    testPanelName = tk.Entry(frame_panel, textvariable = panelName, width = 30)
    testPanelName.grid(row=1, column=2)
    label_panel_example = tk.Label(frame_panel, text='ATLAS ID, e.g. 20USBHP1234567')
    label_panel_example.grid(sticky="w", row=2, column=2)
    
    
    
    
    #hybrid type
    frame_assembly2 = tk.Frame(app)
    frame_assembly2.pack(padx = 10, pady = 10)
    hybridType = tk.Label(frame_assembly2, text='Hybrid Type', width = 10)
    hybridType.grid(row=1, column=1)
    hybrid_type = tk.StringVar()
    radio_X = tk.Radiobutton (frame_assembly2, text='X', variable=hybrid_type, value= 'X' )
    radio_Y = tk.Radiobutton (frame_assembly2, text='Y', variable=hybrid_type, value= 'Y')
    radio_X.select()
    #assemblyName.set('LIV-X-')
    radio_X.grid(row=1, column=2)
    radio_Y.grid(row=1, column=3)
    
    
    
    
    
    
    #position on panel
    frame_panelPos = tk.Frame(app)
    frame_panelPos.pack()
    panelPosLabel = tk.Label(frame_panelPos, text='Hybrid Position on Panel: ', width = 20)
    panelPosLabel.grid(row=1, column=1)
    hybrid_panel_position = ttk.Combobox(frame_panelPos, width=5)
    hybrid_panel_position['values'] = ('0', '1', '2', '3', '4', '5')
    hybrid_panel_position.grid(row=1, column=2)
    
    
    
    
    
    #used tools
    frame_panelTools = tk.Frame(app)
    frame_panelTools.pack()
    row_value = 0
    
    row_value += 1
    panelJigLabel = tk.Label(frame_panelTools, text='Panel Jig: ', width=15)
    panelJigLabel.grid(row=row_value, column=1)
    #panelJig = tk.StringVar()
    #panelJigName = tk.Entry(frame_panelTools, textvariable=panelJig, width=30)
    #panelJigName.grid(row=1, column=2)
    
    panelJigName = ttk.Combobox(frame_panelTools, width=20)
    panelJigName['values'] = ('#020')
    panelJigName.current(0)
    panelJigName.grid(row=row_value, column=2)
    
    
    
    
    row_value += 1
    panelPickUpLabel = tk.Label(frame_panelTools, text='PickUp Tool: ', width=15)
    panelPickUpLabel.grid(row=row_value, column=1)
    #panelPickUp = tk.StringVar()
    #panelPickUpName = tk.Entry(frame_panelTools, textvariable=panelPickUp, width=30)
    #panelPickUpName.grid(row=2, column=2)
    
    panelPickUpName = ttk.Combobox(frame_panelTools, width=20)
    panelPickUpName['values'] = ('X: #005', 'Y: #006')
    panelPickUpName.grid(row=row_value, column=2)
    
    
    row_value += 1
    glueSyringeLabel = tk.Label(frame_panelTools, text='Glue Syringe: ', width=15)
    glueSyringeLabel.grid(row=row_value, column=1)
    glueSyringeName = ttk.Combobox(frame_panelTools, width=20)
    glueSyringeName['values'] = ('20USBGL0000005 (expired)', '20USBGL0000014')
    glueSyringeName.current(1)
    glueSyringeName.grid(row=row_value, column=2)
    
    
    row_value += 1
    chipTrayLabel = tk.Label(frame_panelTools, text='Chip Tray: ', width=15)
    chipTrayLabel.grid(row=row_value, column=1)
    chipTrayName = ttk.Combobox(frame_panelTools, width=20)
    chipTrayName['values'] = ('PPB Prototype 1', 'PPA Stencil')
    chipTrayName.current(0)
    chipTrayName.grid(row=row_value, column=2)
    
    
    row_value += 1
    localNameLabel = tk.Label(frame_panelTools, text='LocalName: ', width=15)
    localNameLabel.grid(row=row_value, column=1)
    localName = tk.StringVar()
    localNameName = tk.Entry(frame_panelTools, textvariable = localName, width = 20)
    localNameName.grid(row=row_value, column=2)
    
    

    
    
    #hybrid flex name
    frame_flex = tk.Frame(app)
    frame_flex.pack(padx = 10, pady = 10)
    flexLabel = tk.Label(frame_flex, text='Hybrid Flex ID: ', width = 15 )
    flexLabel.grid(row=1, column=1)
    flexName = tk.StringVar()
    hybridFlexName = tk.Entry(frame_flex, textvariable = flexName, width = 30)
    hybridFlexName.grid(row=1, column=2)
    label_flex_example = tk.Label(frame_flex, text='Format: <Batch>_<type>_<number>_<letter>_<hybrid>')
    label_flex_example.grid(sticky="w",row=2, column=2)
    label_flex_example2 = tk.Label(frame_flex, text='e.g.: GPC1919_X_003_A_H2')
    label_flex_example2.grid(sticky="w",row=3, column=2)
    

    
    
    #hybrid assembly name
    frame_assembly = tk.Frame(app)
    frame_assembly.pack(padx = 10, pady = 10)
    assemblyLabel = tk.Label(frame_assembly, text='Hybrid Assembly: ', width = 18 )
    assemblyLabel.grid(row=1, column=1)
    assemblyName = tk.StringVar()
    hybridAssemblyName = tk.Entry(frame_assembly, textvariable = assemblyName, width = 20)
    hybridAssemblyName.grid(row=1, column=2)
    assemblyNameSN = tk.StringVar()
    hybridAssemblySNName = tk.Entry(frame_assembly, textvariable = assemblyNameSN, width = 20)
    hybridAssemblySNName.grid(row=1, column=3)
    #label_assembly_example = tk.Label(frame_assembly, text='Altnernative ID, e.g. LIV-X-0012')
    #label_assembly_example.grid(sticky="w", row=2, column=2)
    
    
    
    
    
    #def type_trace(self, *args):
    #    #print( hybrid_type.get() )
    #    if hybrid_type.get()=='X':
    #        assemblyName.set('LIV-X-')
    #    elif hybrid_type.get()=='Y':
    #        assemblyName.set('LIV-Y-')
    #    hybridFlexName.delete(0,'end')
        
        
    #hybrid_type.trace('w', type_trace)
    
    
    
    ##standard process (difference only in step 1)
    #1) create hybrid assembly
    #1.1) output ATLAS ID and alternative ID
    #2) assemble hybrid assembly to panel
    #3) assemble flex to hybrid assembly
    #3.1) disassmble flex from array
    #3.2) assemble to hybrid assembly
    #4) assemble ASICs to hybrid assembly
    #4.1) maybe check if ASICs are assembled to gel-pack and then disassemble
    
    
    
    
    
    
    
    
      ####current process
    #1) get hybrid assembly name
    #  1.1) output ATLAS ID and alternative ID
    #2) assemble hybrid assembly to panel
    #3) assemble flex to hybrid assembly
    #  3.1) disassmble flex from array
    #  3.2) assemble to hybrid assembly
    #4) assemble ASICs to hybrid assembly

    
    def create_assembly():
        hybridAssemblyName.delete(0,'end')
        hybridAssemblyName.configure({'background': 'white'})
        hybridAssemblySNName.delete(0,'end')
        hybridAssemblySNName.configure({'background': 'white'})
        
        global client
        if not client:
            box.showwarning( 'Warning', 'Please Get Passwords first.' )
            return
        if not hybrid_panel_position.get():
            print('Hybrid Position on Panel required.')
            return
        if not panelJigName.get() or not panelPickUpName.get():
            print('Used tools are required')
            return
        if not glueSyringeName.get():
            print('Glue Syringe required')
            return
        if not hybridFlexName.get():
            print('Enter a hybrid flex name')
            return
        
        
      
        
        
        print( '==============================================================')
        print( 'Test Panel Name: ', testPanelName.get().strip() )
        print( 'Position on Panel: ', hybrid_panel_position.get() )
        print( 'Panel Jig: ', panelJigName.get(), '\tPick-Up Tool: ', panelPickUpName.get())
        print( 'Hybrid Flex: ', hybridFlexName.get().strip() )
        
        
        
        if hybrid_type.get() == "Y" and hybrid_panel_position.get() in ('1', '3', '5'):
            box.showwarning( 'Warning', f"Hybrid of type Y can not be assembled to slot {hybrid_panel_position.get()}.")
            return False
        
        

        
        #get hybrid test panel from database and check location
        db_test_panel = client.get('getComponent', json={
                "component":testPanelName.get() 
                })
        if db_test_panel["currentLocation"]["code"] != "LIV":
            box.showwarning( 'Warning', f"Panel {testPanelName.get()} is not at Liverpool." )
            return False
        
        
        #get hybrid flex from database and check location, assembly status and type
        db_hybrid_flex = client.get('getComponent', json={
                "component":hybridFlexName.get(), 
                "alternativeIdentifier": True 
                })
        if db_hybrid_flex["currentLocation"]["code"] != "LIV":
            box.showwarning( 'Warning', f"Hybrid Flex {hybridFlexName.get()} is not at Liverpool." )
            return False
        if db_hybrid_flex["parents"][-1]["componentType"]["code"] == "HYBRID_ASSEMBLY" :
            box.showwarning( 'Warning', f"Hybrid Flex {hybridFlexName.get()} is already assembled to a hybrid.")
            print(f"Hybrid Flex {hybridFlexName.get()} is already assembled to a hybrid.")
            return False
        if db_hybrid_flex["type"]["code"] != hybrid_type.get():
            box.showwarning( 'Warning', f"Hybrid Flex {hybridFlexName.get()} is of the wrong type.")
            return False
            
        
        
        #get flex array from database and check location
        db_hybrid_array = client.get('getComponent', json={
                "component":hybridFlexName.get().strip('_0123456789H'), 
                "alternativeIdentifier": True 
                })
        if db_hybrid_array["currentLocation"]["code"] != "LIV":
            box.showwarning( 'Warning', f"Hybrid Flex {hybridFlexName.get()} is not at Liverpool." )
            return False
        
        
        
        
        print( 'Test Panel: ', db_test_panel["serialNumber"], '; ', db_test_panel["alternativeIdentifier"])
        
        #create hybrid assembly
        hybrid_assembly = client.post('registerComponent', json={"project" : 'S',
                                      "subproject": 'SB',
                                      "institution": 'LIV',
                                      "componentType": 'HYBRID_ASSEMBLY',
                                      "type": hybrid_type.get(),
                                      "properties":{
                                          "ASSEMBLY_PICKUP_TOOL": panelPickUpName.get(),
                                          "ASSEMBLY_JIG": panelJigName.get(),
                                          "ASSEMBLY_CHIPTRAY": chipTrayName.get(),
                                          "GLUE_SYRINGE":glueSyringeName.get() ,
                                          "PICK_AND_PLACE_MACHINE": False,
                                          "LOCAL_NAME": localName.get()
                                      }
                                      })
        #print(json.dumps(hybrid_assembly, indent=3) )
        time.sleep(3)

        db_hybrid_assembly = client.get('getComponent', json={"component":hybrid_assembly["component"]["id"]})
        #print(json.dumps(db_hybrid_assembly, indent=3) )
        
        
        assemblyName.set(db_hybrid_assembly["alternativeIdentifier"])
        assemblyNameSN.set(db_hybrid_assembly["serialNumber"])
        hybridAssemblyName.configure({'background': 'green'})
        hybridAssemblySNName.configure({'background': 'green'})
        print('-------')
        print( 'Hybrid Assembly: ', db_hybrid_assembly["serialNumber"], '; ', db_hybrid_assembly["alternativeIdentifier"] )
        print('-------')
        
        
        
        
        
   
        
        #assemble hybrid assembly to test panel
        asm_hybrid_panel = client.post('assembleComponent', json={
            "parent" : db_test_panel["code"],
            "child" : db_hybrid_assembly["code"],
            "properties":{
                "HYBRID_POSITION" : hybrid_panel_position.get(),
                "JIG_FOR_HYBRID_PLACEMENT" : panelJigName.get(),
                "PICKUPTOOL_FOR_HYBRID_PLACEMENT" : panelPickUpName.get()
            }
        })
        print('Hybrid Assembly assembled to Test Panel')
        
        
        #########################################
        #if not already, change panel stage to show that hybrids are assembled
        #########################################
        
        
        
        
        #assemble hybrid flex to hybrid assembly
        ##1 disassemble hybrid flex from array
        #db_hybrid_flex = client.get('getComponent', json={
        #        "component":hybridFlexName.get(), 
        #        "alternativeIdentifier": True 
        #        })
        #db_hybrid_array = client.get('getComponent', json={
        #        "component":hybridFlexName.get().strip('_0123456789H'), 
        #        "alternativeIdentifier": True 
        #        })
        disasm_hybrid_flex = client.post('disassembleComponent', json={ 
            "parent": db_hybrid_array["code"],
            "child": db_hybrid_flex["code"],
            "trashed": False
        })
        print('Hybrid Flex disassembled from Hybrid Array')
        
        
        time.sleep(2)
        ##2 assemble hybrid flex to hybrid assembly
        asm_hybrid_flex = client.post('assembleComponent', json={
            "parent" : db_hybrid_assembly["code"],
            "alternativeIdentifierParent" : False,
            "child" : db_hybrid_flex["code"],
            "alternativeIdentifierChild" : False
        })
        print('Hybrid Flex assembled to Hybrid Assembly')
        
        ##3 set hybrid flex stage to On Hybrid
        stage_hybrid_flex = client.post("setComponentStage", json={
            'component' : db_hybrid_flex["code"], 
            'stage' : "ON_HYBRID"
        })
        
        
    
              
        box.showinfo( 'Info', 'Hybrid fully assembled.' )
        
        
        
        
        ##reset all values that might be different
        # hybrid flex name, hcc ID & position, abc id & position,  hybrid assembly id
        
        
        hybrid_panel_position.set('')
        localName.set('')
        
        hybridFlexName.delete(0,'end')
        #hybridAssemblyName.delete(6,'end')
    
    
    
    create_button = tk.Button(app, text='Create', width = 20, command = create_assembly )
    create_button.pack(  padx = 10, pady = 10) 
    
    
    
    #def create_trace(self, *args):
    #    hybridAssemblyName.configure({'background': 'white'})
    #    hybridAssemblySNName.configure({'background': 'white'})
    #hybrid_panel_position.get().trace_add('w', create_trace)
    
    
    
    def new():
        hybridAssemblyName.delete(0,'end')
        hybridAssemblyName.configure({'background': 'white'})
        hybridAssemblySNName.delete(0,'end')
        hybridAssemblySNName.configure({'background': 'white'})
        hybridFlexName.delete(0,'end')
        hybrid_panel_position.delete(0,'end')
        localName.set('')


    
    frame_new = tk.Frame(app)
    frame_new.pack(padx = 10, pady = 10)
    
    new_button =tk.Button(frame_new, text='New', width = 20, command = new )
    new_button.grid(row=0, column=2)
    
    
    
    def clear_all():
        hybridAssemblyName.delete(0,'end')
        hybridAssemblyName.configure({'background': 'white'})
        hybridAssemblySNName.delete(0,'end')
        hybridAssemblySNName.configure({'background': 'white'})
        testPanelName.delete(0,'end')
        hybrid_panel_position.delete(0,'end')
        #panelJigName.delete(0,'end')
        panelPickUpName.delete(0,'end')
        hybridFlexName.delete(0,'end')
        localName.set('')
        print("All cleared.")
        
        
    frame_clear = tk.Frame(app)
    frame_clear.pack(padx = 10, pady = 10)    
    
    
    clear_all_button = tk.Button(frame_clear, text='Clear All', width = 20, command = clear_all )
    clear_all_button.grid(row=0, column=2)
    
    
    
    
    
    def close_window():
        app.destroy()
        global db_password1, db_password2, client
        client = None
        db_password1 = None   #delete password when window is closed
        db_password2 = None   #delete password whwn window is closed    
    
    exit_button = tk.Button(app, text='Close', width=25, command=close_window, bg = 'red' )
    exit_button.pack(padx = 10, pady = 10)
        
        
    app.mainloop()

    
    
    
    
    
  

  
    
if __name__ == "__main__":
    window = tk.Tk()
    ##window.withdraw()
    
    quit_button = tk.Button(window, text='Close All', width=25, command=window.destroy, bg = 'red' )
    quit_button.pack(padx = 10, pady = 10)
    
    
    hybrid_assembly_interface()
    
    


# In[ ]:




