#!/usr/bin/env python
# coding: utf-8

# to do:
# 
# automatic stage change for hybrid flex to "On hybrid"

# In[1]:


import tkinter as tk
import tkinter.messagebox as box
from tkinter import filedialog
from tkinter import ttk
import json
import itkdb
import time
import os

def hybrid_assembly_interface():

    #global variables from function access
    global client
    client = None

    
    app = tk.Toplevel()
    app.title('User Interface')

    
    
    #bring window to top and make active
    app.lift()
    app.focus_force()
    app.grab_set()
    app.grab_release()
        
    
    label_head = tk.Label(app, text='Hybrid Flex Panel Registration', bg='blue', fg='white', font=('Arial Black', 12, 'bold'))
    label_head.pack(padx = 10, pady = 10)
    
    
    #####Password verification
    
    
    frame_pw1 = tk.Frame(app)
    frame_pw1.pack(padx=10, pady=10)
    
    label_pw = tk.Label(frame_pw1, text='Please enter database passwords and press button first.'
                        , wraplength=300 ,width=50, justify='left', bg='yellow') 
    label_pw.grid(row=0, column=1, columnspan=2)
    
    
    label_pw1 = tk.Label(frame_pw1, text='Access Code 1: ')
    label_pw1.grid(sticky="w", row=1, column=1)
    pw1 = tk.StringVar()
    entry_pw1 = tk.Entry(frame_pw1, textvariable = pw1)
    entry_pw1['show'] = '*'
    entry_pw1.grid(sticky="w", row=1, column=2)

    label_pw2 = tk.Label(frame_pw1, text='Access Code 2: ')
    label_pw2.grid(sticky="w", row=2, column=1)
    pw2 = tk.StringVar()
    entry_pw2 = tk.Entry(frame_pw1, textvariable = pw2)
    entry_pw2['show'] = '*'
    entry_pw2.grid(sticky="w", row=2, column=2)
  
    


    def pw_read():
        global client
        db_password1 = pw1.get()
        db_password2 = pw2.get()
        if db_password1 and db_password2 :
            try:
                u = itkdb.core.User(access_code1=db_password1, access_code2=db_password2)
                client = itkdb.Client(user = u)
                client.user.authenticate()
                user = client.get('getUser', json={'userIdentity': client.user.identity})
                print( "Hello {} {}, \nwelcome to the ITk database'".format(user["firstName"], user["lastName"]))
                entry_pw1.configure({'background': 'lime'})
                entry_pw2.configure({'background': 'lime'})
                label_pw.configure({'background': 'lightgrey'})
                pw_button.configure({'background': 'lime'})
            except Exception as e:
                print(e)
                box.showerror( 'Error', 'Wrong Passwords' )
                db_password1 = None
                db_password2 = None
                pw1.set('')
                pw2.set('')
                entry_pw1.configure({'background': 'red'})
                entry_pw2.configure({'background': 'red'}) 
                pw_button.configure({'background': 'red'})
                client = None
        elif "ITKDB_ACCESS_CODE1" in os.environ and "ITKDB_ACCESS_CODE1" in os.environ:
            try: 
                client = itkdb.Client()
                client.user.authenticate()
                user = client.get('getUser', json={'userIdentity': client.user.identity})
                print( "Hello {} {}, \nwelcome to the ITk database'".format(user["firstName"], user["lastName"]))
                entry_pw1.configure({'background': 'lime'})
                entry_pw2.configure({'background': 'lime'})
                label_pw.configure({'background': 'lightgrey'})
                pw_button.configure({'background': 'lime'})
            except Exception as e:
                box.showerror( 'Error', 'Wrong Passwords' )
                db_password1 = None
                db_password2 = None
                pw1.set('')
                pw2.set('')
                entry_pw1.configure({'background': 'red'})
                entry_pw2.configure({'background': 'red'})
                pw_button.configure({'background': 'red'})
                client = None
        elif os.path.exists(".env"):
            try: 
                client = itkdb.Client()
                client.user.authenticate()
                dbUser = client.get('getUser', json={'userIdentity': client.user.identity})
                print( "Hello {} {}, \nwelcome to the ITk database".format(dbUser["firstName"], dbUser["lastName"]))
                entry_pw1.configure({'background': 'lime'})
                entry_pw2.configure({'background': 'lime'})
                label_pw.configure({'background': 'lightgrey'})
                pw_button.configure({'background': 'lime'})
            except Exception as e:
                box.showerror( 'Error', 'Wrong Passwords' )
                db_password1 = None
                db_password2 = None
                pw1.set('')
                pw2.set('')
                entry_pw1.configure({'background': 'red'})
                entry_pw2.configure({'background': 'red'})
                pw_button.configure({'background': 'red'})
                client = None
        else: 
            box.showwarning( 'Warning', 'Please Enter Passwords' )
            entry_pw1.configure({'background': 'yellow'})
            entry_pw2.configure({'background': 'yellow'}) 
            client = None

    pw_button = tk.Button(frame_pw1, text='Get Password', width=25, command = pw_read, bg='yellow' )
    pw_button.grid(row=3, column=1, columnspan=2)
    
    
    label_subsection = tk.Label(app, text='Hybrid Assembly', bg='deepskyblue', fg='black', font=('Arial Black', 10))
    label_subsection.pack(padx = 10, pady = 10)
    
    
       
    
    
    
   
    
    
    
    
       
    #hybrid assembly name
    frame_assembly = tk.Frame(app)
    frame_assembly.pack(padx = 10, pady = 10)
    assemblyLabel = tk.Label(frame_assembly, text='Hybrid Assembly alternative ID: ', width = 25 )
    assemblyLabel.grid(row=1, column=1)
    assemblyName = tk.StringVar()
    hybridAssemblyName = tk.Entry(frame_assembly, textvariable = assemblyName, width = 30)
    hybridAssemblyName.grid(row=1, column=2)
    label_assembly_example = tk.Label(frame_assembly, text='Altnernative ID, e.g. LIV-X-0012')
    label_assembly_example.grid(sticky="w", row=2, column=2)
    
    #hybrid type
    frame_assembly2 = tk.Frame(app)
    frame_assembly2.pack()
    hybridType = tk.Label(frame_assembly2, text='Hybrid Type', width = 10)
    hybridType.grid(row=3, column=1)
    hybrid_type = tk.StringVar()
    radio_X = tk.Radiobutton (frame_assembly2, text='X', variable=hybrid_type, value= 'X' )
    radio_Y = tk.Radiobutton (frame_assembly2, text='Y', variable=hybrid_type, value= 'Y')
    radio_X.select()
    assemblyName.set('LIV-X-')
    radio_X.grid(row=3, column=2)
    radio_Y.grid(row=3, column=3)
    
    
###############################    
    
    
    

    
    
    #input for ASICs
    frame_asics = tk.Frame(app)
    frame_asics.pack(padx = 10, pady = 10)
        
    
    header_chip_id = tk.Label(frame_asics, text='Chip Position', width=10, bg='grey')
    header_chip_id.grid(row=0, column=1)
    header_chip_db_id = tk.Label(frame_asics, text='Chip DB ID', width=17, bg='grey')
    header_chip_db_id.grid(row=0, column=2)

    
    hcc_id = tk.StringVar()
    hcc_id.set('HCC_X_0')
    hcc_label = tk.Label (frame_asics, textvariable=hcc_id, width=10, bg='silver')
    hcc_label.grid(row=1, column=1)
    hcc_db_id = tk.StringVar()
    hcc_db_id_entry = tk.Entry(frame_asics, textvariable=hcc_db_id, width=17)
    hcc_db_id_entry.grid(row=1, column=2)
    hcc_db_id.set('20USGAH')

    
    abc0_id = tk.StringVar()
    abc0_id.set('ABC_X_9')
    abc0_label = tk.Label (frame_asics, textvariable=abc0_id, width=10, bg='silver')
    abc0_label.grid(row=2, column=1)
    abc0_db_id = tk.StringVar()
    abc0_db_id_entry = tk.Entry(frame_asics, textvariable=abc0_db_id, width=17)
    abc0_db_id_entry.grid(row=2, column=2)
    abc0_db_id.set('20USGAA')

    
    
    abc1_id = tk.StringVar()
    abc1_id.set('ABC_X_8')
    abc1_label = tk.Label (frame_asics, textvariable=abc1_id, width=10, bg='silver')
    abc1_label.grid(row=3, column=1)
    abc1_db_id = tk.StringVar()
    abc1_db_id_entry = tk.Entry(frame_asics, textvariable=abc1_db_id, width=17)
    abc1_db_id_entry.grid(row=3, column=2)
    abc1_db_id.set('20USGAA')

    
    abc2_id = tk.StringVar()
    abc2_id.set('ABC_X_7')
    abc2_label = tk.Label (frame_asics, textvariable=abc2_id, width=10, bg='silver')
    abc2_label.grid(row=4, column=1)
    abc2_db_id = tk.StringVar()
    abc2_db_id_entry = tk.Entry(frame_asics, textvariable=abc2_db_id, width=17)
    abc2_db_id_entry.grid(row=4, column=2)
    abc2_db_id.set('20USGAA')

    
    abc3_id = tk.StringVar()
    abc3_id.set('ABC_X_6')
    abc3_label = tk.Label (frame_asics, textvariable=abc3_id, width=10, bg='silver')
    abc3_label.grid(row=5, column=1)
    abc3_db_id = tk.StringVar()
    abc3_db_id_entry = tk.Entry(frame_asics, textvariable=abc3_db_id, width=17)
    abc3_db_id_entry.grid(row=5, column=2)
    abc3_db_id.set('20USGAA')

    
    abc4_id = tk.StringVar()
    abc4_id.set('ABC_X_5')
    abc4_label = tk.Label (frame_asics, textvariable=abc4_id, width=10, bg='silver')
    abc4_label.grid(row=6, column=1)
    abc4_db_id = tk.StringVar()
    abc4_db_id_entry = tk.Entry(frame_asics, textvariable=abc4_db_id, width=17)
    abc4_db_id_entry.grid(row=6, column=2)
    abc4_db_id.set('20USGAA')

    
    abc5_id = tk.StringVar()
    abc5_id.set('ABC_X_4')
    abc5_label = tk.Label (frame_asics, textvariable=abc5_id, width=10, bg='silver')
    abc5_label.grid(row=7, column=1)
    abc5_db_id = tk.StringVar()
    abc5_db_id_entry = tk.Entry(frame_asics, textvariable=abc5_db_id, width=17)
    abc5_db_id_entry.grid(row=7, column=2)
    abc5_db_id.set('20USGAA')

    
    abc6_id = tk.StringVar()
    abc6_id.set('ABC_X_3')
    abc6_label = tk.Label (frame_asics, textvariable=abc6_id, width=10, bg='silver')
    abc6_label.grid(row=8, column=1)
    abc6_db_id = tk.StringVar()
    abc6_db_id_entry = tk.Entry(frame_asics, textvariable=abc6_db_id, width=17)
    abc6_db_id_entry.grid(row=8, column=2)
    abc6_db_id.set('20USGAA')

    
    abc7_id = tk.StringVar()
    abc7_id.set('ABC_X_2')
    abc7_label = tk.Label (frame_asics, textvariable=abc7_id, width=10, bg='silver')
    abc7_label.grid(row=9, column=1)
    abc7_db_id = tk.StringVar()
    abc7_db_id_entry = tk.Entry(frame_asics, textvariable=abc7_db_id, width=17)
    abc7_db_id_entry.grid(row=9, column=2)
    abc7_db_id.set('20USGAA')

    
    abc8_id = tk.StringVar()
    abc8_id.set('ABC_X_1')
    abc8_label = tk.Label (frame_asics, textvariable=abc8_id, width=10, bg='silver')
    abc8_label.grid(row=10, column=1)
    abc8_db_id = tk.StringVar()
    abc8_db_id_entry = tk.Entry(frame_asics, textvariable=abc8_db_id, width=17)
    abc8_db_id_entry.grid(row=10, column=2)
    abc8_db_id.set('20USGAA')

    
    abc9_id = tk.StringVar()
    abc9_id.set('ABC_X_0')
    abc9_label = tk.Label (frame_asics, textvariable=abc9_id, width=10, bg='silver')
    abc9_label.grid(row=11, column=1)
    abc9_db_id = tk.StringVar()
    abc9_db_id_entry = tk.Entry(frame_asics, textvariable=abc9_db_id, width=17)
    abc9_db_id_entry.grid(row=11, column=2)
    abc9_db_id.set('20USGAA')

    
    
    
    
    
    
    def type_trace(self, *args):
        #print( hybrid_type.get() )
        if hybrid_type.get()=='X':
            hcc_id.set('HCC_X_0')
            abc0_id.set('ABC_X_9')
            abc1_id.set('ABC_X_8')
            abc2_id.set('ABC_X_7')
            abc3_id.set('ABC_X_6')
            abc4_id.set('ABC_X_5')
            abc5_id.set('ABC_X_4')
            abc6_id.set('ABC_X_3')
            abc7_id.set('ABC_X_2')
            abc8_id.set('ABC_X_1')
            abc9_id.set('ABC_X_0')
            assemblyName.set('LIV-X-')
        elif hybrid_type.get()=='Y':
            hcc_id.set('HCC_Y_0')
            abc0_id.set('ABC_Y_0')
            abc1_id.set('ABC_Y_1')
            abc2_id.set('ABC_Y_2')
            abc3_id.set('ABC_Y_3')
            abc4_id.set('ABC_Y_4')
            abc5_id.set('ABC_Y_5')
            abc6_id.set('ABC_Y_6')
            abc7_id.set('ABC_Y_7')
            abc8_id.set('ABC_Y_8')
            abc9_id.set('ABC_Y_9')
            assemblyName.set('LIV-Y-')
        
        
    hybrid_type.trace('w', type_trace)
    
    
    
    ##standard process (difference only in step 1)
    #1) create hybrid assembly
    #1.1) output ATLAS ID and alternative ID
    #2) assemble hybrid assembly to panel
    #3) assemble flex to hybrid assembly
    #3.1) disassmble flex from array
    #3.2) assemble to hybrid assembly
    #4) assemble ASICs to hybrid assembly
    #4.1) maybe check if ASICs are assembled to gel-pack and then disassemble
    

    
    def create_assembly():
        global client
        if not client:
            box.showwarning( 'Warning', 'Please get database access first.' )
            return
        if not hcc_db_id.get() or not abc0_db_id.get()                 or not abc1_db_id.get()                 or not abc2_db_id.get()                 or not abc3_db_id.get()                 or not abc4_db_id.get()                 or not abc5_db_id.get()                 or not abc6_db_id.get()                 or not abc7_db_id.get()                 or not abc8_db_id.get()                 or not abc9_db_id.get():
            print('Please enter all Chip database IDs')
            return
        
        
        
        print( '==============================================================')
        def check_asic(asic_id):
            print(f"Checking {asic_id}")
            try: 
                asic = client.get('getComponent', json={
                    "component": asic_id,
                    "alternativeIdentifier": False
                    })
            except:
                box.showwarning( 'Warning', f"ASIC {asic_id} does not exist." )
                return False
            
            if asic["currentLocation"]["code"] != "LIV":
                box.showwarning( 'Warning', f"ASIC {asic_id} is not at Liverpool." )
                return False
            if asic["assembled"]:
                if asic["parents"][-1]["componentType"]["code"] == "HYBRID_ASSEMBLY" :
                    box.showwarning( 'Warning', f"ASIC {asic_id} is already assembled to a hybrid.")
                    print(f"ASIC {asic_id} is already assembled to a hybrid.")
                    return False
                print ( f"ASIC was assembled to {asic['parents'][-1]['componentType']['code']}, now disassembling")
                disassemble_asic = client.post('disassembleComponent', json= {
                    "parent": asic["parents"][-1]["component"]["code"],
                    "child": asic["code"],
                    "trashed": False
                })
            return True
                
        
            
            
   
        if check_asic( hcc_db_id.get() ) == False : return
        if check_asic( abc0_db_id.get() ) == False : return
        if check_asic( abc1_db_id.get() ) == False : return
        if check_asic( abc2_db_id.get() ) == False : return
        if check_asic( abc3_db_id.get() ) == False : return
        if check_asic( abc4_db_id.get() ) == False : return
        if check_asic( abc5_db_id.get() ) == False : return
        if check_asic( abc6_db_id.get() ) == False : return
        if check_asic( abc7_db_id.get() ) == False : return
        if check_asic( abc8_db_id.get() ) == False : return
        if check_asic( abc9_db_id.get() ) == False : return
        
        
        
        
        
        print( '==============================================================')
        print( 'Hybrid Assembly: ', hybridAssemblyName.get().strip() )
        
        print( 'HCC: ', hcc_id.get(), ' ', hcc_db_id.get() )
        print( 'ABC0: ', abc0_id.get(), ' ', abc0_db_id.get() )
        
        
        
        
        #get hybrid assembly from database
        try:
            db_hybrid_assembly = client.get('getComponent', json={
                    "component":hybridAssemblyName.get(),
                    "alternativeIdentifier":True 
                    })
            print( 'Hybrid Assembly: ', db_hybrid_assembly["serialNumber"], '; ', db_hybrid_assembly["alternativeIdentifier"] )
        except:
            box.showwarning( 'Warning', f"Hybrid Assembly {hybridAssemblyName.get()} does not exist." )
            return
        
        if db_hybrid_assembly["currentLocation"]["code"] != "LIV":
            box.showwarning( 'Warning', f"Hybrid Assembly {hybridAssemblyName.get()} is not at Liverpool." )
            return
        
        
       
        
        
        #assemble ASICs to hybrid assembly
        def hcc_assembly():
            i = 0
            n_tries = 10
            while i < n_tries:
                try:
                    asm_hcc = client.post('assembleComponent', json={
                        "parent" : db_hybrid_assembly["code"],
                        "child" : hcc_db_id.get(),
                        "properties": {
                            "POSITION_ON_WAFER" : int( hcc_db_id.get()[-3:] )
                        }
                    })
                    break
                except:
                    print(f"Failedl to assembly HCC, {n_tries-i+1} tries left")
                    i += 1
                    continue
        
        hcc_assembly()
        print('HCC assembled to Hybrid Assembly')
        
        
        def abc_assembly(abc_name, abc_position):
            i = 0
            n_tries = 10
            while i < n_tries:
                try:
                    asm_abc = client.post('assembleComponent', json={
                        "parent" : db_hybrid_assembly["code"],
                        "child" : abc_name,
                        "properties": {
                            "ABC_POSITION": abc_position,
                            "POSITION_ON_WAFER" : int(abc_name[-3:])
                        }
                    })
                    break
                except:
                    print(f"Failedl to assembly {abc_position}, {n_tries-i+1} tries left")
                    i += 1
                    continue 
            
        abc_assembly( abc0_db_id.get(), abc0_id.get() )
        abc_assembly( abc1_db_id.get(), abc1_id.get() )
        abc_assembly( abc2_db_id.get(), abc2_id.get() )
        abc_assembly( abc3_db_id.get(), abc3_id.get() )
        abc_assembly( abc4_db_id.get(), abc4_id.get() )
        abc_assembly( abc5_db_id.get(), abc5_id.get() )
        abc_assembly( abc6_db_id.get(), abc6_id.get() )
        abc_assembly( abc7_db_id.get(), abc7_id.get() )
        abc_assembly( abc8_db_id.get(), abc8_id.get() )
        abc_assembly( abc9_db_id.get(), abc9_id.get() )
        print('ABC assembled to Hybrid Assembly')
        print( '==============================================================')
    
              
        box.showinfo( 'Info', 'Hybrid fully assembled.' )
        
        
        
        
        ##reset all values that might be different   
        
        
        hybridAssemblyName.delete(6,'end')
        hcc_db_id_entry.delete(11,'end')
        abc0_db_id_entry.delete(11,'end')   
        abc1_db_id_entry.delete(11,'end')        
        abc2_db_id_entry.delete(11,'end')        
        abc3_db_id_entry.delete(11,'end')        
        abc4_db_id_entry.delete(11,'end')        
        abc5_db_id_entry.delete(11,'end')        
        abc6_db_id_entry.delete(11,'end')        
        abc7_db_id_entry.delete(11,'end')        
        abc8_db_id_entry.delete(11,'end')
        abc9_db_id_entry.delete(11,'end')
    
    
    
    create_button = tk.Button(app, text='Assemble ASICs', width = 20, command = create_assembly )
    create_button.pack(  padx = 10, pady = 10) 
    
    
    
    
    
    
    def clear_abc_wafer():
        abc0_db_id.set('20USGAA')        
        abc1_db_id.set('20USGAA')
        abc2_db_id.set('20USGAA')        
        abc3_db_id.set('20USGAA')        
        abc4_db_id.set('20USGAA')        
        abc5_db_id.set('20USGAA')        
        abc6_db_id.set('20USGAA')        
        abc7_db_id.set('20USGAA')        
        abc8_db_id.set('20USGAA')        
        abc9_db_id.set('20USGAA')
        print("ABC cleared")
    
    def clear_hcc_wafer():
        hcc_db_id.set('20USGAH')
        print("HCC cleared")
    
    
    def clear_all():
        clear_abc_wafer()
        clear_hcc_wafer()
        if hybrid_type.get()=='X': assemblyName.set('LIV-X-')
        elif hybrid_type.get()=='Y':  assemblyName.set('LIV-Y-')
        print("All cleared.")
        
        
    frame_clear = tk.Frame(app)
    frame_clear.pack(padx = 10, pady = 10)    
    
    clear_abc_wafer_button = tk.Button(frame_clear, text='Clear ABC Wafer', width = 20, command = clear_abc_wafer )
    clear_abc_wafer_button.grid(row=0, column=0)
    
    clear_hcc_wafer_button = tk.Button(frame_clear, text='Clear HCC Wafer', width = 20, command = clear_hcc_wafer )
    clear_hcc_wafer_button.grid(row=0, column=1)
    
    clear_all_button = tk.Button(frame_clear, text='Clear All', width = 20, command = clear_all )
    clear_all_button.grid(row=0, column=2)
    
    
    
    
    
    def close_window():
        app.destroy()
        global db_password1, db_password2, client
        client = None
        db_password1 = None   #delete password when window is closed
        db_password2 = None   #delete password whwn window is closed    
    
    exit_button = tk.Button(app, text='Close', width=25, command=close_window, bg = 'red' )
    exit_button.pack(padx = 10, pady = 10)
        
        
    app.mainloop()

    
    
    
    
    
  

  
    
if __name__ == "__main__":
    window = tk.Tk()
    ##window.withdraw()
    
    quit_button = tk.Button(window, text='Close All', width=25, command=window.destroy, bg = 'red' )
    quit_button.pack(padx = 10, pady = 10)
    
    
    hybrid_assembly_interface()
    
    


# In[ ]:




