#!/usr/bin/env python
# coding: utf-8

# In[1]:


import tkinter as tk
from tkinter import ttk
from tkinter import filedialog
import tkinter.messagebox as box
from glob import glob
from datetime import datetime, timezone, date
import json
from tkcalendar import DateEntry

def hybridglueweight_popup():
    
    
    
    
    app_VI = tk.Toplevel()
    
    #bring app_VIdow to top and make active
    app_VI.lift()
    app_VI.focus_force()
    app_VI.grab_set()
    app_VI.grab_release()
   
    app_VI.title('Hybrid Glue Weight Interface')
    
    labelTitle = tk.Label(app_VI, text='Hybrid Glue Weight', bg='blue', fg='white', font=('Arial Black', 12, 'bold'))
    labelTitle.pack(padx = 10, pady = 10)

    
    
    
    
    
    
    frame_line1 = tk.Frame(app_VI)
    frame_line1.pack()
    compnameLabel = tk.Label(frame_line1, text='Database ID: ', width = 15 )
    compnameLabel.pack(side = tk.LEFT, padx = 10, pady = 10)
    componentName = tk.StringVar()
    compname = tk.Entry(frame_line1, textvariable = componentName)
    compname.pack(side = tk.RIGHT, padx = 10, pady = 10)
    #componentName.trace('w', compname.configure({'background': 'white'}))
    
    def trace_feature(self, *args):
        compname.configure({'background': 'white'})
        gwCalculatedLabel.configure({'background': 'grey'})
        gwCalculated.set('')
        seepage_flag_no.select()
        
        
    
    componentName.trace('w', trace_feature )
    
    
    frame_line2 = tk.Frame(app_VI)
    frame_line2.pack()
    altIdLabel = tk.Label(frame_line2, text='Alternative ID?', width = 15 )
    altIdLabel.pack( side=tk.LEFT, padx=10, pady=10)
    altID = tk.BooleanVar()
    radio_alt_no = tk.Radiobutton (frame_line2, text='False', variable = altID, value = False)
    radio_alt_yes = tk.Radiobutton (frame_line2, text='True', variable = altID, value = True)
    radio_alt_yes.select()
    radio_alt_no.pack( side = tk.RIGHT )
    radio_alt_yes.pack( side = tk.RIGHT )
    
    
    
    
    
    frame_line51 = tk.Frame(app_VI)
    frame_line51.pack()
    runNumberLabel = tk.Label(frame_line51, text='Run Number: ', width = 15 )
    runNumberLabel.pack( side=tk.LEFT, padx=10, pady=10 )
    runNumber = ttk.Combobox(frame_line51, width = 5)
    runNumber['values'] = ( '1',
                            '2',
                            '3',
                            '4',
                            '5',
                            '6',
                            '7',
                            '8',
                            '9',
                            '10')
    runNumber.pack( side=tk.RIGHT, padx=10, pady=10)
    runNumber.set('1')
    
    
    

    
    
    frame_Weights = tk.Frame(app_VI)
    frame_Weights.pack()
    
    hybridLable = tk.Label(frame_Weights, text='Bare Hybrid Weight [mg]: ', width = 25)
    hybridLable.grid(row=1, column=1)
    hybridWeight = tk.StringVar()
    hybridWeightValue = tk.Entry(frame_Weights, textvariable = hybridWeight, width = 10)
    hybridWeightValue.grid(row=1, column=2)
    
    HCCLable = tk.Label(frame_Weights, text='HCCStar Weight [mg]: ', width = 25)
    HCCLable.grid(row=2, column=1)
    HCCWeight = tk.StringVar()
    HCCWeightValue = tk.Entry(frame_Weights, textvariable = HCCWeight, width = 10)
    HCCWeightValue.grid(row=2, column=2)
    
    ABCLable = tk.Label(frame_Weights, text='ABCStar Weight [mg]: ', width = 25)
    ABCLable.grid(row=3, column=1)
    ABCWeight = tk.StringVar()
    ABCWeightValue = tk.Entry(frame_Weights, textvariable = ABCWeight, width = 10)
    ABCWeightValue.grid(row=3, column=2)
    
    assemblyLable = tk.Label(frame_Weights, text='Assembled Hybrid Weight [mg]: ', width = 25)
    assemblyLable.grid(row=4, column=1)
    assemblyWeight = tk.StringVar()
    assemblyWeightValue = tk.Entry(frame_Weights, textvariable = assemblyWeight, width = 10)
    assemblyWeightValue.grid(row=4, column=2)
    
    
    #Option for measurement date
    date_Label = tk.Label(frame_Weights, text='Measurement Date: ', width = 25)
    date_Label.grid(row=5, column=1)
    cal = DateEntry(frame_Weights, width=12, background='darkblue', maxdate=date.today(), 
                    foreground='white', borderwidth=2, dateformat=4, date_pattern='yyyy-mm-dd')
    cal.grid(row=5, column=2)
    
    
    calculatedLable = tk.Label(frame_Weights, text='Glue Weight [mg]: ', width = 25)
    calculatedLable.grid(row=6, column=1)
    gwCalculated = tk.StringVar()
    gwCalculatedLabel = tk.Label(frame_Weights, textvariable=gwCalculated, width=10, bg='grey')
    gwCalculatedLabel.grid(row=6, column=2)
    
    
    frame_seepage = tk.Frame(app_VI)
    frame_seepage.pack()
    seepage_flagLabel = tk.Label(frame_seepage, text='Glue Seepage affecting bonding: ', width = 25 )
    seepage_flagLabel.pack( side=tk.LEFT, padx=10, pady=10)
    seepage_flag = tk.BooleanVar()
    seepage_flag_no = tk.Radiobutton (frame_seepage, text='No', variable = seepage_flag, value = False)
    seepage_flag_yes = tk.Radiobutton (frame_seepage, text='Yes', variable = seepage_flag, value = True)
    seepage_flag_no.select()
    seepage_flag_no.pack( side = tk.RIGHT )
    seepage_flag_yes.pack( side = tk.RIGHT )
    
    
    
    
    
    
    
    
    ##input measured weights
    
    ##calculate glue weight
    
    #pass/fail from calculated weight
    
    
    
    
    
    
    
    
    
    
  
    
    
    
    
    def get_save_directory():
        saveDirectory.set( filedialog.askdirectory(initialdir = "./",title = "Select Directory") )
        #print ( saveDirectory.get() )
    
    
    frame_line8 = tk.Frame(app_VI)
    frame_line8.pack()
    directoryLabel = tk.Label(frame_line8, text='Json saved in directory:', width=20)
    directoryLabel.pack(side = tk.LEFT, padx=10, pady=10)
    dir_button = tk.Button(frame_line8, text='Save Directory', width = 20, command = get_save_directory )
    dir_button.pack( side= tk.RIGHT, padx = 10, pady = 10)
    
    saveDirectory = tk.StringVar()
    saveDirLabel = tk.Label(app_VI, textvariable=saveDirectory, width=60, bg='grey', wraplength=350)
    saveDirLabel.pack(padx=10, pady=10)
    
    
    
    
    def create_json():
        print ( "Component Name: ", componentName.get() )
        
        
        if componentName.get() == '' or assemblyWeight.get() == '' or HCCWeight.get() == '' or             ABCWeight.get() == '' or  hybridWeight.get() == '' or saveDirectory.get() == '':
            box.showerror( 'Error', 'Please Complete all user fields and pick a save directory.' )
        else:
            
            gw_hybrid = float(assemblyWeight.get()) - float(HCCWeight.get()) - float(ABCWeight.get()) - float(hybridWeight.get())
            gwCalculated.set( round(gw_hybrid,2) )
            
            
            if seepage_flag.get() == True:       #seepage affecting wire-bonding is always failed
                gwCalculatedLabel.configure({'background': 'red'})
                passed = False
                problems = False
            elif 41.18 <= gw_hybrid <= 46.42:
                gwCalculatedLabel.configure({'background': 'green'})
                passed = True
                problems = False
            elif gw_hybrid < 41.18:              #low glue weight is always fail
                gwCalculatedLabel.configure({'background': 'red'})
                passed = False
                problems = False
            else:
                gwCalculatedLabel.configure({'background': 'orange'})
                passed = True
                problems = True
            
            
            #Measurement Date (using current time)
            datetimeobject = datetime.combine( cal.get_date(), datetime.now(timezone.utc).time() )
            
            
            out_dictionary = {}  ##dictionary for output
            out_dictionary.update({"componentType": "HYBRID_ASSEMBLY" }) 
            out_dictionary.update({"component": componentName.get() })             
            out_dictionary.update({"alternativeIdentifier": altID.get() })    
            out_dictionary.update({"currentStage": "ASIC_ATTACHMENT" })        
            out_dictionary.update({"testType" : "ASIC_GLUE_WEIGHT" })
            out_dictionary.update({"institution" : "LIV"})
            out_dictionary.update({"runNumber" : int( runNumber.get() ) })                           
            out_dictionary.update({"date" : datetimeobject.astimezone().isoformat(timespec='milliseconds')  })      
            out_dictionary.update({"passed" : passed })
            out_dictionary.update({"problems" : problems })
            out_dictionary.update({"properties": None  })
            out_dictionary.update({"results" : {
                                    "GW_HYBRID_HT" : round( float(hybridWeight.get())/1000.0 , 4) ,   #bare hybrid with tabs
                                    "GW_GLUE_ASICS" : round( gw_hybrid/1000.0 , 4),     #glue under ASICs
                                    "GW_HYBRID_HTGA" : round( float(assemblyWeight.get())/1000.0 , 4),  #hybrid with tabs, glue and asics
                                    "GW_ASIC" : round( ( float(HCCWeight.get()) + float(ABCWeight.get()) )/1000.0 , 4)  #asic weight
                                    } })
            if seepage_flag.get() == True:
                out_dictionary.update({"comments" : ["Glue Seepage Affecting Wire Bonding."]    })
            
            
            
            
            #########save json file#######################################
    
            out_file_name = componentName.get() + '_ASIC_GLUE_WEIGHT_' + runNumber.get()
            out_file = saveDirectory.get() +'\\' + out_file_name + '.json'
 
            print(f"Json output file: {out_file}")
            
            with open( out_file, 'w' ) as outfile:
                json.dump(out_dictionary, outfile, indent=4)  #indent makes it human readable
            
            
            compname.configure({'background': 'lime'})
            assemblyWeight.set('')
            HCCWeight.set('')
            ABCWeight.set('')
            hybridWeight.set('')
            seepage_flag_no.select()
            
    
    
    def clear_fields():
        compname.delete(0,'end')
        saveDirectory.set('')


    
    
    frame_button = tk.Frame(app_VI)
    frame_button.pack()
    create_button = tk.Button(frame_button, text='Create Json', width = 25, command=create_json)
    create_button.pack(side = tk.LEFT, padx = 10, pady = 10)
    clear_button = tk.Button(frame_button, text='Clear All', width = 25, command=clear_fields)
    clear_button.pack(side = tk.RIGHT, padx = 10, pady = 10)
    
    
    
    
    
    exit_button = tk.Button(app_VI, text='Close', width=25, command=app_VI.destroy, bg = 'red' )
    exit_button.pack(padx = 10, pady = 10)


    app_VI.mainloop()
    
    
    
    
if __name__ == "__main__":
    window = tk.Tk()
    #window.withdraw()
    
    quit_button = tk.Button(window, text='Close All', width=25, command=window.destroy, bg = 'red' )
    quit_button.pack(padx = 10, pady = 10)
    
    hybridglueweight_popup()
 


# {
# 	"componentType": "HYBRID_ASSEMBLY",
# 	"component": "LIV-X-0001",
# 	"alternativeIdentifier": true,
# 	"currentStage": "ASIC_ATTACHMENT",
# 	"testType": "ASIC_GLUE_WEIGHT",
# 	"institution": "LIV",
# 	"runNumber": 10,
# 	"date": "2021-09-13T09:31:37.756+1:00",
# 	"passed": true,
# 	"problems": false,
# 	"properties" : null,
# 	"results" : {
# 		"GW_HYBRID_HT" : 1235.67,   #bare hybrid with tabs
# 		"GW_GLUE_ASICS" : 15.6,     #glue under ASICs
# 		"GW_HYBRID_HTG" : 3246.37,  #hybrid with tabs and glue
# 		"GW_HYBRID_HTGA" : 756.82,  #hybrid with tabs, glue and asics
# 		"GW_ASIC" : 35.2            #asic weight
# 	}
# }
