#!/usr/bin/env python
# coding: utf-8

# In[ ]:


#based on script from https://gitlab.cern.ch/dengfeng/ITkDBAPI


import os
import itkdb
import requests
import json
import getpass
import argparse
import traceback
      
        
def upload(client, inJSONFileName, componentID, altID):

    if not os.path.isfile(inJSONFileName):
        print("inFile: "+inJSONFileName+" doesn't exist!!!!")
        return

    if not client:
        print("Please Login Database!")
        return
    inFile = open(inJSONFileName, "r")
    if not inFile: exit(1)
    data  = json.load(inFile)

    if "testType" not in data:
        print("Need to know test type, short code")
        exit(1)
    if "institution" not in data:
        print("Need to know institution, short code")
        exit(1)

    if "results" not in data:
        print("Need some test results")
        exit(1)

    #if data["component"]==None or data["component"]=="":
    #data["component"] = componentID
    #data["alternativeIdentifier"] = altID   #added for alternative identifier
    #data.update({"component": componentID})
    #data.update({"alternativeIdentifier": altID})

    try:
        comp = client.get('getComponent', json={"component": componentID, "alternativeIdentifier": altID})
        data.update( { "component": comp["code"] } )
        response = client.post('uploadTestRunResults', json=data)
        return True
    except Exception:
        print("Failed to uploadTestRunResults.")
        traceback.print_exc()
        return False


