#!/usr/bin/env python
# coding: utf-8

# In[2]:


import tkinter as tk
import tkinter.messagebox as box
from tkinter import filedialog
from PIL import ImageTk, Image

import pull_test_interface as pull_interface

#import database_interface as db_interface

import json_upload_interface as json_upload
import stage_transition_interface as stage_transition

import visual_inspection_interface as vi_interface

import flex_panel_registration_interface as flex_reg_interface

#import hybrid_assembly_interface_V0 as hybrid_assembly_interface
import hybrid_assembly_interface_V0_1 as hybrid_assembly_interface1
import hybrid_assembly_interface_V0_2 as hybrid_assembly_interface2

import flex_qc_interface as flex_qc_interface

import flex_thickness_interface as flex_thickness_interface

import hybrid_glue_weight_interface as hybrid_glue_weight

import module_glue_weight_interface as module_glue_weight

import hybridmodule_etest_interface as etest_upload

import database_lookup_interface as db_lookup

import shipping_interface as db_shipping

def gui_interface():

    #global variables from function access
    
    

    app = tk.Tk()
    app.title('User Interface')

    #bring window to top and make active
    app.lift()
    app.focus_force()
    app.grab_set()
    app.grab_release()



    #Liverpool logo
    image = Image.open('Liv-Logo.jpg')
    image_width, image_height = image.size 
    #print(width, '\t', height)
    image_scalefactor = 0.25
    image = image.resize( ( int(image_scalefactor*image_width), int(image_scalefactor*image_height) ), Image.Resampling.LANCZOS)
    my_img = ImageTk.PhotoImage(image)
    my_imgd = tk.Label( image = my_img )
    my_imgd.pack()
    

    label_top = tk.Label(app, text='Liverpool ATLAS Upgrade Interface', bg='blue', fg='white', font=('Arial Black', 12, 'bold'))
    label_top.pack(padx = 10, pady = 10)

    #################################
    
    frame_database = tk.Frame(app)
    frame_database.pack(padx=10, pady=10)
    
    labe_database = tk.Label(frame_database, text='Database Interactions', bg='yellow')
    labe_database.grid(row=0, column = 0, padx = 10, pady = 10, columnspan = 3)
    
    
    json_button = tk.Button(frame_database, text='Json Upload Interface', width = 25, command = json_upload.upload_interface )
    json_button.grid( row = 1, column = 0, padx = 1, pady = 1)
    
    stage_buttona = tk.Button(frame_database, text='Stage Transition Interface', width = 25, command = stage_transition.stage_transition_interface )
    stage_buttona.grid( row = 1, column = 1, padx = 1, pady = 1)
    
    
    db_lookup_button = tk.Button(frame_database, text='Database Component Lookup', width = 25, command = db_lookup.lookup_interface)
    db_lookup_button.grid( row = 1, column = 2, padx = 1, pady = 1)
    
    db_shipping_button = tk.Button(frame_database, text='Shipping Interface', width = 25, command = db_shipping.shipping_interface)
    db_shipping_button.grid( row = 2, column = 1, padx = 1, pady = 1)
    
    
    
    
    #db_shipping
    
    
    
    ################################
    
    frame_general = tk.Frame(app)
    frame_general.pack(padx=10, pady=10)
    
    labe_general = tk.Label(frame_general, text='General Scripts', bg='yellow')
    labe_general.grid(row=0, column = 0, padx = 10, pady = 10, columnspan = 3)
    
    
    vi_button = tk.Button(frame_general, text='Visual Inspection', width = 20, command = vi_interface.visualinspection_popup )
    vi_button.grid( row = 1, column = 0, padx = 1, pady = 1)

    pull_button = tk.Button(frame_general, text='Pull Test Analysis', width = 20, command = pull_interface.pull_popup )
    pull_button.grid( row = 1, column = 1, padx = 1, pady = 1)
    
    
    etest_upload_button = tk.Button(frame_general, text='Electrical Test Upload', width = 20, command = etest_upload.etest_interface )
    etest_upload_button.grid( row = 1, column = 2, padx = 1, pady = 1)
    
    
    ################################
    
    frame_flex = tk.Frame(app)
    frame_flex.pack(padx=10, pady=10)
    
    labe_flex = tk.Label(frame_flex, text='Hybrid Flex', bg='yellow')
    labe_flex.grid(row=0, column = 0, padx = 10, pady = 10, columnspan = 3)
    
    
    reg_button = tk.Button(frame_flex, text='Hybrid Flex Registration', width = 20,                            command = flex_reg_interface.flex_panel_registration_interface )
    reg_button.grid( row = 1, column = 0, padx = 1, pady = 1)
    
    flex_button = tk.Button(frame_flex, text='Flex QC Analysis', width = 20, command = flex_qc_interface.flex_qc_popup )
    flex_button.grid( row = 1, column = 1, padx = 1, pady = 1)
    
    flex_thickness_button = tk.Button(frame_flex, text='Flex Thickness', width = 20, command = flex_thickness_interface.flex_thickness_popup )
    flex_thickness_button.grid( row = 1, column = 2, padx = 1, pady = 1)
    
    
    ################################
    
    
    
    frame_hybrid = tk.Frame(app)
    frame_hybrid.pack(padx=10, pady=10)
    
    labe_hybrid = tk.Label(frame_hybrid, text='Hybrid', bg='yellow')
    labe_hybrid.grid(row=0, column = 0, padx = 10, pady = 10, columnspan = 3)
    
    
    #hybrid_asm_button = tk.Button(frame_hybrid, text='Hybrid Assembly', width = 20, command = hybrid_assembly_interface.hybrid_assembly_interface )
    #hybrid_asm_button.grid( row = 1, column = 0, padx = 1, pady = 1)
    
    hybrid_asm_button1 = tk.Button(frame_hybrid, text='Hybrid Assembly 1', width = 20, command = hybrid_assembly_interface1.hybrid_assembly_interface )
    hybrid_asm_button1.grid( row = 1, column = 0, padx = 1, pady = 1)
    
    hybrid_asm_button2 = tk.Button(frame_hybrid, text='Hybrid Assembly 2', width = 20, command = hybrid_assembly_interface2.hybrid_assembly_interface )
    hybrid_asm_button2.grid( row = 1, column = 1, padx = 1, pady = 1)
    
    hybrid_glue_button = tk.Button(frame_hybrid, text='Hybrid Glue Weight', width = 20, command = hybrid_glue_weight.hybridglueweight_popup )
    hybrid_glue_button.grid( row = 2, column = 1, padx = 1, pady = 1)
    
    
    labe07 = tk.Label(frame_hybrid, text='Hybrid Assembly needs to be updated')
    labe07.grid(row = 3, column = 0, padx = 10, pady = 10, columnspan = 2)
    
    
    ################################

    
    
    
    frame_module = tk.Frame(app)
    frame_module.pack(padx=10, pady=10)
    
    labe_module = tk.Label(frame_module, text='Module', bg='yellow')
    labe_module.grid(row=0, column = 0, padx = 10, pady = 10, columnspan = 3)
    
    
    module_glue_button = tk.Button(frame_module, text='Module Glue Weight', width = 20, command = module_glue_weight.moduleglueweight_popup )
    module_glue_button.grid( row = 1, column = 1, padx = 1, pady = 1)
    
    
    
    
    ################################
    
    
    labe01 = tk.Label(app, text='Missing', bg='red')
    labe01.pack(padx = 10, pady = 10)
    
    
    labe02 = tk.Label(app, text='Module Assembly')
    labe02.pack(padx = 1, pady = 1)
    
    labe03 = tk.Label(app, text='Hybrid and Module Metrology')
    labe03.pack(padx = 1, pady = 1)
    
    
    labe05 = tk.Label(app, text='Wire Bond (hybrid or module)')
    labe05.pack(padx = 1, pady = 1)
    
    
    
    
    
    
    
    
    
    



    exit_button = tk.Button(app, text='Close All', width=25, command=app.destroy, bg = 'red' )
    exit_button.pack(padx = 10, pady = 10)

    app.mainloop()

    
    
if __name__ == "__main__":
    gui_interface()


# In[ ]:




