#!/usr/bin/env python
# coding: utf-8

# # To Do
# 
# read module info
# read hybrid info
# read powerboard info
# 
# 1) disassemble hybrid from panel
# 2) assemble hybrid to module
# 2.1) change hybrid stage to "on module"
# 3) disassemble powerboard from panel
# 4) assemble powerboard to module
# 4.1) change powerboard stage to "loaded on a module"
# 5) change module stage to "glued"
# 
# add tooling information from assembly (all the jigs)
# 
# a switch to distinguis between SS and LS
# - use this to set up some pre-fixes in the user fields for module, hybrid and powerboard
# 
# 
# 
# maybe also add the glue test as part of this GUI
# 
# add visual inspection after gluing as part of GUI
# 
# --
# 
# 
# 
# ---
# module not disassembled from frame, to save work

# In[2]:


import tkinter as tk
import tkinter.messagebox as box
from tkinter import filedialog
from tkinter import ttk
import json
import itkdb
import time

def module_assembly_interface():
    #global variables from function access

    #global variables from function access
    global client
    client = None

    
    app = tk.Toplevel()
    app.title('User Interface')

    
    
    #bring window to top and make active
    app.lift()
    app.focus_force()
    app.grab_set()
    app.grab_release()
        
    
    label_head = tk.Label(app, text='Module Assembly', bg='blue', fg='white', font=('Arial Black', 12, 'bold'))
    label_head.pack(padx = 10, pady = 10)
    
    
    #####Password verification
    
    
    frame_pw1 = tk.Frame(app)
    frame_pw1.pack(padx=10, pady=10)
    
    label_pw = tk.Label(frame_pw1, text='Please enter database passwords and press button first.'
                        , wraplength=300 ,width=50, justify='left', bg='yellow') 
    label_pw.grid(row=0, column=1, columnspan=2)
    
    
    label_pw1 = tk.Label(frame_pw1, text='Access Code 1: ')
    label_pw1.grid(sticky="w", row=1, column=1)
    pw1 = tk.StringVar()
    entry_pw1 = tk.Entry(frame_pw1, textvariable = pw1)
    entry_pw1['show'] = '*'
    entry_pw1.grid(sticky="w", row=1, column=2)

    label_pw2 = tk.Label(frame_pw1, text='Access Code 2: ')
    label_pw2.grid(sticky="w", row=2, column=1)
    pw2 = tk.StringVar()
    entry_pw2 = tk.Entry(frame_pw1, textvariable = pw2)
    entry_pw2['show'] = '*'
    entry_pw2.grid(sticky="w", row=2, column=2)
  
    


    def pw_read():
        global client
        db_password1 = pw1.get()
        db_password2 = pw2.get()
        if db_password1 and db_password2 :
            try:
                u = itkdb.core.User(access_code1=db_password1, access_code2=db_password2)
                client = itkdb.Client(user = u)
                client.user.authenticate()
                user = client.get('getUser', json={'userIdentity': client.user.identity})
                print( "Hello {} {}, \nwelcome to the ITk database'".format(user["firstName"], user["lastName"]))
                entry_pw1.configure({'background': 'lime'})
                entry_pw2.configure({'background': 'lime'})
                label_pw.configure({'background': 'lightgrey'})
                pw_button.configure({'background': 'lime'})
            except Exception as e:
                print(e)
                box.showerror( 'Error', 'Wrong Passwords' )
                db_password1 = None
                db_password2 = None
                pw1.set('')
                pw2.set('')
                entry_pw1.configure({'background': 'red'})
                entry_pw2.configure({'background': 'red'}) 
                pw_button.configure({'background': 'red'})
                client = None
        elif "ITKDB_ACCESS_CODE1" in os.environ and "ITKDB_ACCESS_CODE1" in os.environ:
            try: 
                client = itkdb.Client()
                client.user.authenticate()
                user = client.get('getUser', json={'userIdentity': client.user.identity})
                print( "Hello {} {}, \nwelcome to the ITk database'".format(user["firstName"], user["lastName"]))
                entry_pw1.configure({'background': 'lime'})
                entry_pw2.configure({'background': 'lime'})
                label_pw.configure({'background': 'lightgrey'})
                pw_button.configure({'background': 'lime'})
            except Exception as e:
                box.showerror( 'Error', 'Wrong Passwords' )
                db_password1 = None
                db_password2 = None
                pw1.set('')
                pw2.set('')
                entry_pw1.configure({'background': 'red'})
                entry_pw2.configure({'background': 'red'})
                pw_button.configure({'background': 'red'})
                client = None
        elif os.path.exists(".env"):
            try: 
                client = itkdb.Client()
                client.user.authenticate()
                dbUser = client.get('getUser', json={'userIdentity': client.user.identity})
                print( "Hello {} {}, \nwelcome to the ITk database".format(dbUser["firstName"], dbUser["lastName"]))
                entry_pw1.configure({'background': 'lime'})
                entry_pw2.configure({'background': 'lime'})
                label_pw.configure({'background': 'lightgrey'})
                pw_button.configure({'background': 'lime'})
            except Exception as e:
                box.showerror( 'Error', 'Wrong Passwords' )
                db_password1 = None
                db_password2 = None
                pw1.set('')
                pw2.set('')
                entry_pw1.configure({'background': 'red'})
                entry_pw2.configure({'background': 'red'})
                pw_button.configure({'background': 'red'})
                client = None
        else: 
            box.showwarning( 'Warning', 'Please Enter Passwords' )
            entry_pw1.configure({'background': 'yellow'})
            entry_pw2.configure({'background': 'yellow'}) 
            client = None

    pw_button = tk.Button(frame_pw1, text='Get Password', width=25, command = pw_read, bg='yellow' )
    pw_button.grid(row=3, column=1, columnspan=2)
    
    
    
    label_subsection = tk.Label(app, text='Module Assembly', bg='deepskyblue', fg='black', font=('Arial Black', 10))
    label_subsection.pack(padx = 10, pady = 10)
    
    
    
    
    
    
    #module type
    moduleName = tk.StringVar()
    
    
    frame_module_type = tk.Frame(app)
    frame_module_type.pack()
    moduleType = tk.Label(frame_module_type, text='Module Type', width = 10)
    moduleType.grid(row=3, column=1)
    module_type = tk.StringVar()
    radio_LS = tk.Radiobutton (frame_module_type, text='LS', variable=module_type, value= 'LS' )
    radio_SS = tk.Radiobutton (frame_module_type, text='SS', variable=module_type, value= 'SS')
    radio_LS.select()
    moduleName.set('20USBML')
    radio_LS.grid(row=3, column=2)
    radio_SS.grid(row=3, column=3)
    
    
    
    
    
    #module name
    frame_module = tk.Frame(app)
    frame_module.pack(padx = 10, pady = 10)
    row_value = 0
    
    row_value +=1
    moduleLabel = tk.Label(frame_module, text='Module ID: ', width = 25, justify=tk.RIGHT, anchor="e" )
    moduleLabel.grid(row=row_value, column=1)
    moduleNameEntry = tk.Entry(frame_module, textvariable = moduleName, width = 20)
    moduleNameEntry.grid(row=row_value, column=2)
    label_module_example = tk.Label(frame_module, text='ATLAS ID, e.g. 20USBML1234567')
    label_module_example.grid(sticky="w", row=row_value, column=3)
    
    
    row_value +=1
    hybridXLabel = tk.Label(frame_module, text='Hybrid X ID: ', width = 25, justify=tk.RIGHT, anchor="e" )
    hybridXLabel.grid(row=row_value, column=1)
    hybridXName = tk.StringVar()
    hybridXName.set('LIV-X-')
    hybridXNameEntry = tk.Entry(frame_module, textvariable = hybridXName, width  = 20)
    hybridXNameEntry.grid(row=row_value, column = 2)
    hybridXNameExample = tk.Label(frame_module, text='Alternative ID, e.g. LIV-X-0012')
    hybridXNameExample.grid(sticky='w', row=row_value, column=3)
    
    
    row_value +=1
    hybridYLabel = tk.Label(frame_module, text='Hybrid Y ID: ', width = 25, justify=tk.RIGHT, anchor="e" )
    hybridYLabel.grid(row=row_value, column=1)
    hybridYName = tk.StringVar()
    hybridYName.set('')
    hybridYNameEntry = tk.Entry(frame_module, textvariable = hybridYName, width  = 20)
    hybridYNameEntry.grid(row=row_value, column = 2)
    hybridYNameEntry.configure(state=tk.DISABLED)
    hybridYNameExample = tk.Label(frame_module, text='Alternative ID, e.g. LIV-Y-0012')
    hybridYNameExample.grid(sticky='w', row=row_value, column=3)
    
    
    row_value +=1
    powerboardLabel = tk.Label(frame_module, text='Powerboard ID: ', width = 25, justify=tk.RIGHT, anchor="e" )
    powerboardLabel.grid(row=row_value, column=1)
    powerboardName = tk.StringVar()
    powerboardName.set('20USBPO')
    powerboardNameEntry = tk.Entry(frame_module, textvariable = powerboardName, width  = 20)
    powerboardNameEntry.grid(row=row_value, column = 2)
    powerboardNameExample = tk.Label(frame_module, text='ATLAS ID, e.g. 40USBPO3000015')
    powerboardNameExample.grid(sticky='w', row=row_value, column=3)
    
    
    
    
    
    
    frame_tools = tk.Frame(app)
    frame_tools.pack(padx = 10, pady = 10)
    row_value = 0
    width_c1 = 20   #label column 1
    width_c2 = 15   #entry column 2
    width_c3 = 20   #label column 3
    width_c4 = 15   #entry column 4
    

    row_value +=1
    moduleJigLabel = tk.Label(frame_tools, text='Module Assembly Jig: ', width=width_c1, justify=tk.RIGHT, anchor="e")
    moduleJigLabel.grid(row=row_value, column=1)
    moduleJigName = ttk.Combobox(frame_tools, width=width_c2)
    moduleJigName['values'] = ('#004')
    moduleJigName.current(0)
    moduleJigName.grid(row=row_value, column=2)
    
    
    row_value +=1
    pickUpXLabel = tk.Label(frame_tools, text='Pick-Up X: ', width=width_c1, justify=tk.RIGHT, anchor="e")
    pickUpXLabel.grid(row=row_value, column=1)
    pickUpXName = ttk.Combobox(frame_tools, width=width_c2)
    pickUpXName['values'] = ('#005')
    pickUpXName.current(0)
    pickUpXName.grid(row=row_value, column=2)
    
    #stencilXLabel = tk.Label(frame_tools, text='Stencil X: ', width=width_c3, justify=tk.RIGHT, anchor="e")
    #stencilXLabel.grid(row=row_value, column=3)
    #stencilXName = ttk.Combobox(frame_tools, width=width_c4)
    #stencilXName['values'] = ('RAL Prototype', '#012')
    #stencilXName.current(0)
    #stencilXName.grid(row=row_value, column=4)
    
    
    
    
    row_value +=1
    pickUpYLabel = tk.Label(frame_tools, text='Pick-Up Y: ', width=width_c1, justify=tk.RIGHT, anchor="e")
    pickUpYLabel.grid(row=row_value, column=1)
    pickUpYName = ttk.Combobox(frame_tools, width=width_c2)
    pickUpYName['values'] = ('#006')
    pickUpYName.current(0)
    pickUpYName.grid(row=row_value, column=2)
    
    #stencilYLabel = tk.Label(frame_tools, text='Stencil Y: ', width=width_c3, justify=tk.RIGHT, anchor="e")
    #stencilYLabel.grid(row=row_value, column=3)
    #stencilYName = ttk.Combobox(frame_tools, width=width_c4)
    #stencilYName['values'] = ('RAL Prototype', '#012')
    #stencilYName.current(0)
    #stencilYName.grid(row=row_value, column=4)
    
    
    
    
    row_value +=1
    hybridGlueLabel = tk.Label(frame_tools, text='Hybrid Glue Sample: ', width = width_c1, justify=tk.RIGHT, anchor="e" )
    hybridGlueLabel.grid(row=row_value, column=1, pady=5)
    hybridGlueName = tk.StringVar()
    hybridGlueName.set('')
    hybridGlueNameEntry = tk.Entry(frame_tools, textvariable = hybridGlueName, width  = width_c2+3)
    hybridGlueNameEntry.grid(row=row_value, column = 2, sticky='w', pady=5)
    hybridGlueNameExample = tk.Label(frame_tools, text='YYYY-MM-DD_S, e.g. 2022-04-12_A')
    hybridGlueNameExample.grid(sticky='w', row=row_value, column=3, columnspan=2, pady=5)
    

    
    #Resin, Hardener - drop down   ->  write to comments if used
    
    row_value +=1
    hResinLabel = tk.Label(frame_tools, text='Hybrid Glue Resin: ', width=width_c1, justify=tk.RIGHT, anchor="e")
    hResinLabel.grid(row=row_value, column=1)
    hResinName = ttk.Combobox(frame_tools, width=width_c2)
    hResinName['values'] = ('Resin1')
    hResinName.current(0)
    hResinName.grid(row=row_value, column=2)
    
    hHardenerLabel = tk.Label(frame_tools, text='Hybrid Glue Hardener: ', width=width_c3, justify=tk.RIGHT, anchor="e")
    hHardenerLabel.grid(row=row_value, column=3)
    hHardenerName = ttk.Combobox(frame_tools, width=width_c4)
    hHardenerName['values'] = ('Hardener1')
    hHardenerName.current(0)
    hHardenerName.grid(row=row_value, column=4)
  
 
  
    
    
    frame_tools2 = tk.Frame(app)
    frame_tools2.pack(padx = 10, pady = 10)
    row_value = 0
    
    
    row_value +=1
    powerboardJigLabel = tk.Label(frame_tools2, text='PB Alignment Jig: ', width=width_c1, justify=tk.RIGHT, anchor="e")
    powerboardJigLabel.grid(row=row_value, column=1)
    powerboardJigName = ttk.Combobox(frame_tools2, width=width_c2)
    powerboardJigName['values'] = ('#004')
    powerboardJigName.current(0)
    powerboardJigName.grid(row=row_value, column=2)
    
    
    row_value +=1
    pickUpPBLabel = tk.Label(frame_tools2, text='Pick-Up PB: ', width=width_c1, justify=tk.RIGHT, anchor="e")
    pickUpPBLabel.grid(row=row_value, column=1)
    pickUpPBName = ttk.Combobox(frame_tools2, width=width_c2)
    pickUpPBName['values'] = ('#004')
    pickUpPBName.current(0)
    pickUpPBName.grid(row=row_value, column=2)
    
    #stencilPBLabel = tk.Label(frame_tools2, text='Stencil PB: ', width=width_c3, justify=tk.RIGHT, anchor="e")
    #stencilPBLabel.grid(row=row_value, column=3)
    #stencilPBName = ttk.Combobox(frame_tools2, width=width_c4)
    #stencilPBName['values'] = ('RAL Prototype', '#XXX')
    #stencilPBName.current(0)
    #stencilPBName.grid(row=row_value, column=4)
    
    
    row_value +=1
    powerboardGlueLabel = tk.Label(frame_tools2, text='PB Glue Sample: ', width = width_c1, justify=tk.RIGHT, anchor="e" )
    powerboardGlueLabel.grid(row=row_value, column=1, pady=5)
    powerboardGlueName = tk.StringVar()
    powerboardGlueName.set('')
    powerboardGlueNameEntry = tk.Entry(frame_tools2, textvariable = powerboardGlueName, width  = width_c2+3)
    powerboardGlueNameEntry.grid(row=row_value, column = 2, sticky='w', pady=5)
    powerboardGlueNameExample = tk.Label(frame_tools2, text='YYYY-MM-DD_S, e.g. 2022-04-12_A')
    powerboardGlueNameExample.grid(sticky='w', row=row_value, column=3, columnspan=2, pady=5)
    
    
    
    row_value +=1
    pResinLabel = tk.Label(frame_tools2, text='PB Glue Resin: ', width=width_c1, justify=tk.RIGHT, anchor="e")
    pResinLabel.grid(row=row_value, column=1)
    pResinName = ttk.Combobox(frame_tools2, width=width_c2)
    pResinName['values'] = ('Resin1')
    pResinName.current(0)
    pResinName.grid(row=row_value, column=2)
    
    pHardenerLabel = tk.Label(frame_tools2, text='PB Glue Hardener: ', width=width_c3, justify=tk.RIGHT, anchor="e")
    pHardenerLabel.grid(row=row_value, column=3)
    pHardenerName = ttk.Combobox(frame_tools2, width=width_c4)
    pHardenerName['values'] = ('Hardener1')
    pHardenerName.current(0)
    pHardenerName.grid(row=row_value, column=4)
    
    
    
    
    
    #Resin, Hardener - drop down   ->  write to comments if used
    
    frame_localName = tk.Frame(app)
    frame_localName.pack(padx = 10, pady = 10)
    row_value = 0
    localNameLabel = tk.Label(frame_localName, text='LocalName: ', width=15)
    localNameLabel.grid(row=row_value, column=1)
    localName = tk.StringVar()
    localNameName = tk.Entry(frame_localName, textvariable = localName, width = 20)
    localNameName.grid(row=row_value, column=2)
    

    
   
    
    
    def type_trace(self, *args):
        #print( hybrid_type.get() )
        if module_type.get()=='LS':
            moduleName.set('20USBML')
            hybridXName.set('LIV-X-')
            hybridYName.set('')
            hybridYNameEntry.configure(state=tk.DISABLED)
        elif module_type.get()=='SS':
            moduleName.set('20USBMS')
            hybridXName.set('LIV-X-')
            hybridYName.set('LIV-Y-')
            hybridYNameEntry.configure(state=tk.NORMAL)

        
        
    module_type.trace('w', type_trace)
    
    
    
    ##standard process
    #1) retrieve module from database
    #==check that it is at Liverpool (and in stage HV-Tab attached or glued)
    #2) retrieve hybrid 1 from database
    #==check that it is at Liverpool, of correct type, assembled to a panel and in stage At module assembly site
    #3) retrieve hybrid 2 from database (if applicable)
    #==check that it is at Liverpool, of correct type, assembled to a panel and in stage At module assembly site
    #4) retrieve powerboard from database
    #==check that it is at Liverpool, assembled to a panel and in stage Module Reception
    
    #5) change module stage to glued (if not already in that stage)
    #6) disassemble hybrids from the test panels (if they are assembled)
    #7) assemble hybrids to module
    #7.1) change hybrid stage to On Module
    #8) disassemble powerboard from panel (if assembled)
    #9) assemble powerboard to module
    #9.1) change powerboard stage to Loaded on Module
    #10) change local name with new value, if new value is set

    
    #Powerboard: PWB
    #Powerboard panel: PWB_CARRIER
    #Types: B3
    #Stages: MODULE_RCP, LOADED
    
    #Hybrid Assembly: HYBRID_ASSEMBLY
    #Test Panel: HYBRID_TEST_PANEL
    #Types: X, Y
    #Stages: AT_MODULE_ASSEMBLY_SITE, ON_MODULE
    
    #Module: MODULE
    #Test Frame: 
    #Types: BARRLE_SS_MODULE, BARREL_LS_MODULE
    #Stages: HV_TB_ATTACHED, GLUED
    #Hybrid Child Properties: JIG_HYBRID_ALIGNMENT, PICKUPTOOL_HYBRID, HYBRID_GLUE_SAMPLE, MODULE_ASSEMBLY_JIG
    #Powerboard Child Properties: JIG_POWERBOARD_ALIGNMENT, PICKUPTOOL_POWERBOARD, POWERBOARD_GLUE_SAMPLE, MODULE_ASSEMBLY_JIG
    
    
    
    
    
    
 

    
    def assemble():
        
        global client
        if not client:
            box.showwarning( 'Warning', 'Please Get Passwords first.' )
            return
       
        
        
      
        
        
        print( '==============================================================')
        print( 'Module Name: ',  )

               
        
       
        time.sleep(2)

        
        
        
        
    
              
        box.showinfo( 'Info', 'Module fully assembled.' )
        
        
        
        
        ##reset all values that might be different
        
    
    
    
    create_button = tk.Button(app, text='Assemble', width = 20, command = assemble )
    create_button.pack(  padx = 10, pady = 10) 
    
    
    
    
    
    
    def new():
        #clear hybrids, powerboard, glue
        #leave tools
        print("new")
    
    
    frame_new = tk.Frame(app)
    frame_new.pack(padx = 10, pady = 10)
    
    new_button =tk.Button(frame_new, text='New', width = 20, command = new )
    new_button.grid(row=0, column=2)
    
    
    
    def clear_all():
        #clear all
        print('Clear')
        
        
    frame_clear = tk.Frame(app)
    frame_clear.pack(padx = 10, pady = 10)    
    
    
    clear_all_button = tk.Button(frame_clear, text='Clear All', width = 20, command = clear_all )
    clear_all_button.grid(row=0, column=2)
    
    
    
    
    
    def close_window():
        app.destroy()
        global db_password1, db_password2, client
        client = None
        db_password1 = None   #delete password when window is closed
        db_password2 = None   #delete password whwn window is closed    
    
    exit_button = tk.Button(app, text='Close', width=25, command=close_window, bg = 'red' )
    exit_button.pack(padx = 10, pady = 10)
        
        
    app.mainloop()

    
    
    
    
    
  

  
    
if __name__ == "__main__":
    window = tk.Tk()
    ##window.withdraw()
    
    quit_button = tk.Button(window, text='Close All', width=25, command=window.destroy, bg = 'red' )
    quit_button.pack(padx = 10, pady = 10)
    
    
    module_assembly_interface()
    


# In[ ]:




