#!/usr/bin/env python
# coding: utf-8

# In[2]:


import tkinter as tk
import tkinter.messagebox as box
from tkinter import filedialog
from tkinter import ttk
import itkdb
from glob import glob
from strip_stage_updater_2 import set_hybrid_stage
import os


def stage_transition_interface():
    #global variables from function access

    #global variables from function access
    global client
    client = None

    
    app = tk.Toplevel()
    app.title('User Interface')

    
    
    #bring window to top and make active
    app.lift()
    app.focus_force()
    app.grab_set()
    app.grab_release()
        
    
    label_head = tk.Label(app, text='Stage Transition Interface', bg='blue', fg='white', font=('Arial Black', 12, 'bold'))
    label_head.pack(padx = 10, pady = 10)
    
    
    #####Password verification
    
    
    frame_pw1 = tk.Frame(app)
    frame_pw1.pack(padx=10, pady=10)
    
    label_pw = tk.Label(frame_pw1, text='Please enter database passwords and press button first.'
                        , wraplength=300 ,width=50, justify='left', bg='yellow') 
    label_pw.grid(row=0, column=1, columnspan=2)
    
    
    label_pw1 = tk.Label(frame_pw1, text='Access Code 1: ')
    label_pw1.grid(sticky="w", row=1, column=1)
    pw1 = tk.StringVar()
    entry_pw1 = tk.Entry(frame_pw1, textvariable = pw1)
    entry_pw1['show'] = '*'
    entry_pw1.grid(sticky="w", row=1, column=2)

    label_pw2 = tk.Label(frame_pw1, text='Access Code 2: ')
    label_pw2.grid(sticky="w", row=2, column=1)
    pw2 = tk.StringVar()
    entry_pw2 = tk.Entry(frame_pw1, textvariable = pw2)
    entry_pw2['show'] = '*'
    entry_pw2.grid(sticky="w", row=2, column=2)
  
    


    def pw_read():
        global client
        db_password1 = pw1.get()
        db_password2 = pw2.get()
        if db_password1 and db_password2 :
            try:
                u = itkdb.core.User(access_code1=db_password1, access_code2=db_password2)
                client = itkdb.Client(user = u)
                client.user.authenticate()
                user = client.get('getUser', json={'userIdentity': client.user.identity})
                print( "Hello {} {}, \nwelcome to the ITk database'".format(user["firstName"], user["lastName"]))
                entry_pw1.configure({'background': 'lime'})
                entry_pw2.configure({'background': 'lime'})
                label_pw.configure({'background': 'lightgrey'})
                pw_button.configure({'background': 'lime'})
            except Exception as e:
                print(e)
                box.showerror( 'Error', 'Wrong Passwords' )
                db_password1 = None
                db_password2 = None
                pw1.set('')
                pw2.set('')
                entry_pw1.configure({'background': 'red'})
                entry_pw2.configure({'background': 'red'}) 
                pw_button.configure({'background': 'red'})
                client = None
        elif "ITKDB_ACCESS_CODE1" in os.environ and "ITKDB_ACCESS_CODE1" in os.environ:
            try: 
                client = itkdb.Client()
                client.user.authenticate()
                user = client.get('getUser', json={'userIdentity': client.user.identity})
                print( "Hello {} {}, \nwelcome to the ITk database'".format(user["firstName"], user["lastName"]))
                entry_pw1.configure({'background': 'lime'})
                entry_pw2.configure({'background': 'lime'})
                label_pw.configure({'background': 'lightgrey'})
                pw_button.configure({'background': 'lime'})
            except Exception as e:
                box.showerror( 'Error', 'Wrong Passwords' )
                db_password1 = None
                db_password2 = None
                pw1.set('')
                pw2.set('')
                entry_pw1.configure({'background': 'red'})
                entry_pw2.configure({'background': 'red'})
                pw_button.configure({'background': 'red'})
                client = None
        elif os.path.exists(".env"):
            try: 
                client = itkdb.Client()
                client.user.authenticate()
                dbUser = client.get('getUser', json={'userIdentity': client.user.identity})
                print( "Hello {} {}, \nwelcome to the ITk database".format(dbUser["firstName"], dbUser["lastName"]))
                entry_pw1.configure({'background': 'lime'})
                entry_pw2.configure({'background': 'lime'})
                label_pw.configure({'background': 'lightgrey'})
                pw_button.configure({'background': 'lime'})
            except Exception as e:
                box.showerror( 'Error', 'Wrong Passwords' )
                db_password1 = None
                db_password2 = None
                pw1.set('')
                pw2.set('')
                entry_pw1.configure({'background': 'red'})
                entry_pw2.configure({'background': 'red'})
                pw_button.configure({'background': 'red'})
                client = None
        else: 
            box.showwarning( 'Warning', 'Please Enter Passwords' )
            entry_pw1.configure({'background': 'yellow'})
            entry_pw2.configure({'background': 'yellow'}) 
            client = None

    pw_button = tk.Button(frame_pw1, text='Get Password', width=25, command = pw_read, bg='yellow' )
    pw_button.grid(row=3, column=1, columnspan=2)
    
    
    
    
    
    label10_text='Script for stage transition of parts with (or without) children.    \nEither use single serial number of provide file with multiple serial numbers'
    label0 = tk.Label(app, text=label10_text, wraplength=300 ,width=40, justify='left') 
    label0.pack(padx = 10, pady = 10)
    
    
    
    
    frame_sn = tk.Frame(app)
    frame_sn.pack()
    label1 = tk.Label(frame_sn, text='Database ID: ', width = 15)
    label1.pack(side = tk.LEFT, padx = 10, pady = 10)
    entry1 = tk.Entry(frame_sn)
    entry1.pack(side = tk.RIGHT, padx = 10, pady = 10)
    
    
    frame_altID = tk.Frame(app)
    frame_altID.pack()
    label_altID = tk.Label(frame_altID, text='Alternative ID: ', width = 15)
    label_altID.pack(side = tk.LEFT, padx = 10, pady = 10)
    altID = tk.IntVar()
    radio_1 = tk.Radiobutton (frame_altID, text='False', variable = altID, value = 0)
    radio_2 = tk.Radiobutton (frame_altID, text='True', variable = altID, value = 1)
    radio_2.select()
    radio_2.pack( side = tk.RIGHT )
    radio_1.pack( side = tk.RIGHT )
    
    
    frame_nstage = tk.Frame(app)
    frame_nstage.pack()
    label2 = tk.Label(frame_nstage, text='New Stage: ', width = 15)
    label2.pack(side = tk.LEFT, padx = 10, pady = 10)
    #entry2 = tk.Entry(frame_nstage)
    #entry2.pack(side = tk.RIGHT, padx = 10, pady = 10)
    entry_stage = ttk.Combobox(frame_nstage, width = 30)
    entry_stage['values'] = ( '===Flex Arrays & Hybrid Flex==='
                             'FROM_MANUFACTURER',
                             'READY_FOR_SMD_ATTACHMENT',
                             'SMD_ATTACHMENT',
                             'SMD_POPULATED',
                             'SMD_COMPLETED',
                             'AT_HYBRID_ASSEMBLY_SITE',
                             'FAILED',
                             'NOT_DELIVERED',
                             'USED',
                             '===Test Coupons===',
                             'AFTER_REFLOW',
                             'QA',
                             'FAILED',
                             'NOT_DELIVERED',
                             'TESTED',
                             '===Hybrid Assembly===',
                             'WIRE_BONDING',
                             'BURN_IN',
                             'FINISHED_HYBRID',
                             'AT_MODULE_ASSEMBLY_SITE',
                             'FAILED',
                             'ON_MODULE',
                             '===Module===',
                             'GLUED',
                             'BONDED',
                             'TESTED',
                             'FINISHED',
                             'AT_LOADING_SITE',
                             'FAILED')
    entry_stage.pack(side = tk.RIGHT, padx = 10, pady = 10)
    
    
    
    
    def stage_single():
        global client
        n_alt_ID = bool( altID.get() )
        if client :
            serial_number = entry1.get()
            new_stage = entry_stage.get()
            if serial_number and new_stage :
                set_hybrid_stage(client, serial_number, n_alt_ID, new_stage)
                box.showinfo( 'Stage Transition', 'Stage Transition Completed.' )
            else:
                box.showwarning( 'Warning', 'Please Enter a Serial Number and a new Stage.' )
        else:
            box.showwarning( 'Warning', 'Please Get Passwords first.' )
    
    
    def stage_file():
        global client
        n_alt_ID = bool( altID.get() )
        if client :
            component_filename =  filedialog.askopenfilename(initialdir = "./",                                           title = "Select file",filetypes = (("text files","*.txt"),("all files","*.*")))
            new_stage = entry_stage.get()
            with open(component_filename) as file:
                for serial_number in file:
                    if serial_number and new_stage :
                        set_hybrid_stage(client, serial_number.rstrip(), n_alt_ID, new_stage)
                        #box.showinfo( 'Stage Transition', 'Stage Transition Completed.' )
                    else:
                        box.showwarning( 'Warning', 'Please Enter a Serial Number and a new Stage.' )
                box.showinfo( 'Stage Transition', 'Stage Transition Completed.' )
        else:
            box.showwarning( 'Warning', 'Please Get Passwords first.' )
        
        
        
    
    
    frame_stage = tk.Frame(app)
    frame_stage.pack()  

    file_button = tk.Button(frame_stage, text='Single Object', width = 20, command = stage_single )
    file_button.pack(side = tk.LEFT, padx = 10, pady = 10)

    dir_button = tk.Button(frame_stage, text='File', width = 20, command = stage_file )
    dir_button.pack( side= tk.RIGHT, padx = 10, pady = 10)
    
    
    
    
    
    
    
    
    def close_window():
        app.destroy()
        global db_password1, db_password2, client
        client = None
        db_password1 = None   #delete password when window is closed
        db_password2 = None   #delete password whwn window is closed


    exit_button = tk.Button(app, text='Close', width=25, command=close_window, bg = 'red' )
    exit_button.pack(padx = 10, pady = 10)
    
    
    
    
    app.mainloop()
    
    
    
    
    
if __name__ == "__main__":
    window = tk.Tk()
    #window.withdraw()
    
        
    quit_button = tk.Button(window, text='Close All', width=25, command=window.destroy, bg = 'red' )
    quit_button.pack(padx = 10, pady = 10)
    
    stage_transition_interface()


# In[ ]:




