#!/usr/bin/env python
# coding: utf-8

# In[1]:


import tkinter as tk
from tkinter import ttk
from tkinter import filedialog
import tkinter.messagebox as box
from glob import glob
from datetime import datetime, timezone, date
import json
from tkcalendar import DateEntry


def visualinspection_popup():
    
    
    
    
    app_VI = tk.Toplevel()
    
    #bring app_VIdow to top and make active
    app_VI.lift()
    app_VI.focus_force()
    app_VI.grab_set()
    app_VI.grab_release()
   
    app_VI.title('Visual Inspection Interface')
    
    labelTitle = tk.Label(app_VI, text='Visual Inspection', bg='blue', fg='white', font=('Arial Black', 12, 'bold'))
    labelTitle.pack(padx = 10, pady = 10)

    
    
    
    
    
    
    frame_line1 = tk.Frame(app_VI)
    frame_line1.pack()
    compnameLabel = tk.Label(frame_line1, text='Database ID: ', width = 15 )
    compnameLabel.pack(side = tk.LEFT, padx = 10, pady = 10)
    componentName = tk.StringVar()
    compname = tk.Entry(frame_line1, textvariable = componentName)
    compname.pack(side = tk.RIGHT, padx = 10, pady = 10)
    #componentName.trace('w', compname.configure({'background': 'white'}))
    
    def trace_feature(self, *args):
        compname.configure({'background': 'white'})
    
    componentName.trace('w', trace_feature )
    
    
    frame_line2 = tk.Frame(app_VI)
    frame_line2.pack()
    altIdLabel = tk.Label(frame_line2, text='Alternative ID?', width = 15 )
    altIdLabel.pack( side=tk.LEFT, padx=10, pady=10)
    altID = tk.BooleanVar()
    radio_alt_no = tk.Radiobutton (frame_line2, text='False', variable = altID, value = False)
    radio_alt_yes = tk.Radiobutton (frame_line2, text='True', variable = altID, value = True)
    radio_alt_yes.select()
    radio_alt_no.pack( side = tk.RIGHT )
    radio_alt_yes.pack( side = tk.RIGHT )
    
    
    frame_line3 = tk.Frame(app_VI)
    frame_line3.pack()
    compTypeLabel = tk.Label(frame_line3, text='Component Type: ', width = 15 )
    compTypeLabel.pack( side=tk.LEFT, padx=10, pady=10 )
    componentTypeVar = tk.StringVar()
    componentType = ttk.Combobox(frame_line3, textvariable = componentTypeVar, width = 30)
    componentType['values'] = ( 'HYBRID_FLEX',
                                'HYBRID_FLEX_ARRAY',
                                'HYBRID_FLEX_PANEL',
                                'HYBRID_ASSEMBLY',
                                'HYBRID_TEST_PANEL',
                                'MODULE' )
    componentType.pack( side=tk.RIGHT, padx=10, pady=10)
    
    
    
    def trace_comment(self, *args):
        componentStage.delete(0,'end')
        if componentTypeVar.get() == 'HYBRID_FLEX_ARRAY':
            comment.delete('1.0','end')
            comment.insert(1.0,"https://cernbox.cern.ch/index.php/s/D6dMNx7erXhLjqO")
        else:
            comment.delete('1.0','end')
        
    
        if componentTypeVar.get() == 'HYBRID_FLEX':
            componentStage['values'] = ( 'FROM_MANUFACTURER',
                                  'SMD_POPULATED',
                                  'SMD_COMPLETED',
                                  'AT_HYBRID_ASSEMBLY_SITE' )
        elif componentTypeVar.get() == 'HYBRID_FLEX_ARRAY':
            componentStage['values'] = ( 'FROM_MANUFACTURER',
                                  'SMD_POPULATED',
                                  'SMD_COMPLETED',
                                  'AT_HYBRID_ASSEMBLY_SITE' )
        elif componentTypeVar.get() == 'HYBRID_FLEX_PANEL':
            componentStage['values'] = ( 'FROM_MANUFACTURER',
                                  'SMD_POPULATED',
                                  'SMD_COMPLETED',
                                  'AT_HYBRID_ASSEMBLY_SITE' )
        elif componentTypeVar.get() == 'HYBRID_ASSEMBLY':
            componentStage['values'] = ( 'ASIC_ATTACHMENT',
                                  'WIRE_BONDING',
                                  'BURN_IN',
                                  'FINISHED_HYBRID',
                                  'AT_MODULE_ASSEMBLY_SITE' )
        elif componentTypeVar.get() == 'HYBRID_TEST_PANEL':
            componentStage['values'] = ( 'HYBRIDS_ASSEMBLED' )
        elif componentTypeVar.get() == 'MODULE':
            componentStage['values'] = ('HV_TAB_ATTACHED',
                                  'GLUED',
                                  'STITCH_BONDING',
                                  'BONDED',
                                  'TESTED',
                                  'FINISHED',
                                  'AT_LOADING_SITE')
        else:
            componentStage['values'] = ('')
    
    componentTypeVar.trace('w', trace_comment )
    
    
    
    
    frame_line4 = tk.Frame(app_VI)
    frame_line4.pack()
    compStageLabel = tk.Label(frame_line4, text='Component Stage: ', width = 15 )
    compStageLabel.pack( side=tk.LEFT, padx=10, pady=10 )
    componentStageVar = tk.StringVar()
    componentStage = ttk.Combobox(frame_line4, textvariable = componentStageVar, width = 30)
    componentStage['values'] = ( '' )
    componentStage.pack( side=tk.RIGHT, padx=10, pady=10)
    
    
    frame_line5 = tk.Frame(app_VI)
    frame_line5.pack()
    testTypeLabel = tk.Label(frame_line5, text='Test Type: ', width = 15 )
    testTypeLabel.pack( side=tk.LEFT, padx=10, pady=10 )
    testType = ttk.Combobox(frame_line5, width = 30)
    testType['values'] = ( '' )
    testType.pack( side=tk.RIGHT, padx=10, pady=10)
    
    
    def trace_type(self, *args):
        testType.delete(0,'end')
        if componentStageVar.get() == 'FROM_MANUFACTURER' and componentTypeVar.get() == 'HYBRID_FLEX':
            testType['values'] = ( 'VISUAL_INSPECTION_BARE')
        elif componentStageVar.get() == 'SMD_POPULATED' and componentTypeVar.get() == 'HYBRID_FLEX':
            testType['values'] = ( 'VISUAL_INSPECTION_SMD')
        
        elif componentStageVar.get() == 'FROM_MANUFACTURER' and componentTypeVar.get() == 'HYBRID_FLEX_ARRAY':
            testType['values'] = ( 'VISUAL_INSPECTION','VISUAL_INSPECTION_BARE')
        elif componentStageVar.get() == 'SMD_POPULATED' and componentTypeVar.get() == 'HYBRID_FLEX_ARRAY':
            testType['values'] = ( 'VISUAL_INSPECTION', 'VISUAL_INSPECTION_SMD')
        else:
            testType['values'] = ( 'VISUAL_INSPECTION',
                            'VISUAL_INSPECTION_RECEPTION' )
    
    componentStageVar.trace('w', trace_type)
    
    
    
    
    
    frame_line51 = tk.Frame(app_VI)
    frame_line51.pack()
    runNumberLabel = tk.Label(frame_line51, text='Run Number: ', width = 15 )
    runNumberLabel.pack( side=tk.LEFT, padx=10, pady=10 )
    runNumber = ttk.Combobox(frame_line51, width = 5)
    runNumber['values'] = ( '1',
                            '2',
                            '3',
                            '4',
                            '5',
                            '6',
                            '7',
                            '8',
                            '9',
                            '10')
    runNumber.pack( side=tk.RIGHT, padx=10, pady=10)
    runNumber.set('1')
    
    
    #Option for measurement date
    frame_line52 = tk.Frame(app_VI)
    frame_line52.pack()
    date_Label = tk.Label(frame_line52, text='Measurement Date: ', width = 25, justify=tk.RIGHT, anchor="e")
    date_Label.grid(row=1, column=1)
    cal = DateEntry(frame_line52, width=12, background='darkblue', maxdate=date.today(), 
                    foreground='white', borderwidth=2, dateformat=4, date_pattern='yyyy-mm-dd')
    cal.grid(row=1, column=2)
    
    
    
    frame_line6 = tk.Frame(app_VI)
    frame_line6.pack()
    passFail = tk.Label(frame_line6, text='Test Result: ', width = 15 )
    passFail.pack( side=tk.LEFT, padx=10, pady=10)
    passed = tk.BooleanVar()
    radio_passed = tk.Radiobutton (frame_line6, text='Passed', variable = passed, value = True)
    radio_failed = tk.Radiobutton (frame_line6, text='Failed', variable = passed, value = False)
    radio_passed.select()
    radio_failed.pack( side = tk.RIGHT )
    radio_passed.pack( side = tk.RIGHT )
    
    
    
    frame_line61 = tk.Frame(app_VI)
    frame_line61.pack()
    problemsLabel = tk.Label(frame_line61, text='Problems: ', width = 15 )
    problemsLabel.pack( side=tk.LEFT, padx=10, pady=10)
    problems = tk.BooleanVar()
    radio_prob_yes = tk.Radiobutton (frame_line61, text='Yes', variable = problems, value = True)
    radio_prob_no = tk.Radiobutton (frame_line61, text='No', variable = problems, value = False)
    radio_prob_no.select()
    radio_prob_no.pack( side = tk.RIGHT )
    radio_prob_yes.pack( side = tk.RIGHT )
    
    
    
    frame_line7 = tk.Frame(app_VI)
    frame_line7.pack()
    commentLabel = tk.Label(frame_line7, text='Comment:', width=10)
    commentLabel.pack(side = tk.LEFT, padx=10)
    comment = tk.Text(frame_line7, width=65, height=5)
    #comment.insert(1.0,"https://cernbox.cern.ch/index.php/s/D6dMNx7erXhLjqO")
    comment.pack(padx=10, pady=10)
    
    
    
    
    def get_save_directory():
        saveDirectory.set( filedialog.askdirectory(initialdir = "./",title = "Select Directory") )
        #print ( saveDirectory.get() )
    
    
    frame_line8 = tk.Frame(app_VI)
    frame_line8.pack()
    directoryLabel = tk.Label(frame_line8, text='Json saved in directory:', width=20)
    directoryLabel.pack(side = tk.LEFT, padx=10, pady=10)
    dir_button = tk.Button(frame_line8, text='Save Directory', width = 20, command = get_save_directory )
    dir_button.pack( side= tk.RIGHT, padx = 10, pady = 10)
    
    saveDirectory = tk.StringVar()
    saveDirLabel = tk.Label(app_VI, textvariable=saveDirectory, width=60, bg='grey', wraplength=350)
    saveDirLabel.pack(padx=10, pady=10)
    
    
    
    
    def create_json():
        print ( "Component Name: ", componentName.get() )
        #print ( "Component Type: ", componentTypeVar.get() )
        #print ( "Component Stage: ", componentStage.get() )
        #print ( "Test Type: ", testType.get() )
        #print ( "Directory: ", saveDirectory.get() )
        #print ( "Comment: ", comment.get('1.0','end-1c') )
        
        if componentName.get() == '' or componentTypeVar.get() == '' or componentStageVar.get() == ''           or testType.get() == '' or saveDirectory.get() == '':
            box.showerror( 'Error', 'Please Complete all user fields and pick a save directory.' )
        else:        
            #Measurement Date (using current time)
            datetimeobject = datetime.combine( cal.get_date(), datetime.now(timezone.utc).time() )
            
            
            out_dictionary = {}  ##dictionary for output
            out_dictionary.update({"componentType": componentTypeVar.get() }) 
            out_dictionary.update({"component": componentName.get() })             
            out_dictionary.update({"alternativeIdentifier": altID.get() })    
            out_dictionary.update({"currentStage": componentStageVar.get() })        
            out_dictionary.update({"testType" : testType.get() })
            out_dictionary.update({"institution" : "LIV"})
            out_dictionary.update({"runNumber" : int( runNumber.get() ) })                           
            out_dictionary.update({"date" : datetimeobject.astimezone().isoformat(timespec='milliseconds') })      
            out_dictionary.update({"passed" : passed.get() })
            out_dictionary.update({"problems" : problems.get() })
            out_dictionary.update({"properties": None  })
            out_dictionary.update({"results" : {}  })
            out_dictionary.update({"comments" : [ comment.get('1.0','end-1c').replace('\n', '; ').strip() ] })
            
            
            
            #########save json file#######################################
    
            out_file_name = componentName.get() + '_VI_' + componentStage.get() + '_' + runNumber.get()
            out_file = saveDirectory.get() +'\\' + out_file_name + '.json'
 
            print(f"Json output file: {out_file}")
            
            with open( out_file, 'w' ) as outfile:
                json.dump(out_dictionary, outfile, indent=4)  #indent makes it human readable
            
            compname.configure({'background': 'lime'})
    
    
    
    def clear_fields():
        compname.delete(0,'end')
        componentTypeVar.set('')
        componentStageVar.set('')
        testType.delete(0,'end')
        comment.delete('1.0','end')
        saveDirectory.set('')
    
    
    frame_button = tk.Frame(app_VI)
    frame_button.pack()
    create_button = tk.Button(frame_button, text='Create Json', width = 25, command=create_json)
    create_button.pack(side = tk.LEFT, padx = 10, pady = 10)
    clear_button = tk.Button(frame_button, text='Clear All', width = 25, command=clear_fields)
    clear_button.pack(side = tk.RIGHT, padx = 10, pady = 10)
    
    
    
    
    
    exit_button = tk.Button(app_VI, text='Close', width=25, command=app_VI.destroy, bg = 'red' )
    exit_button.pack(padx = 10, pady = 10)


    app_VI.mainloop()
    
    
    
    
if __name__ == "__main__":
    window = tk.Tk()
    #window.withdraw()
    
    quit_button = tk.Button(window, text='Close All', width=25, command=window.destroy, bg = 'red' )
    quit_button.pack(padx = 10, pady = 10)
    
    visualinspection_popup()
 


# {
# 	"componentType": "HYBRID_ASSEMBLY",
# 	"component": "LIV-X-0001",
# 	"alternativeIdentifier": true,
# 	"currentStage": "ASIC_ATTACHMENT",
# 	"testType": "VISUAL_INSPECTION",
# 	"institution": "LIV",
# 	"runNumber": 10,
# 	"date": "2021-09-08T11:30:15.3+1:00",
# 	"passed": true,
# 	"problems": false,
# 	"properties" : null,
# 	"results" : {
# 		"IMAGE" : null
# 	},
# 	"comments" : ["Comment 1", "Comment 2", "Comment 3"],
# 	"defects" : [
# 			{
# 					"name" : "defect test 1",
# 					"description" : "Not good"
# 		 },
# 		 {
# 					"name" : "defect test 2",
# 					"description" : "Even Worse"
# 		 }
# 	]
# }

# In[ ]:




